/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.21 from the
 * contents of URPM.xs. Do not edit this file, edit URPM.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "URPM.xs"
/* Copyright (c) 2002, 2003, 2004, 2005 MandrakeSoft SA
 * Copyright (c) 2005, 2006, 2007, 2008, 2009, 2010, 2011 Mandriva SA
 *
 * All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 *
 * $Id: URPM.xs 271602 2011-01-06 16:22:09Z peroyvind $
 * 
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/utsname.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <libintl.h>

#undef Fflush
#undef Mkdir
#undef Stat
#undef Fstat

#define _RPMGI_INTERNAL
#define _RPMEVR_INTERNAL
#define _RPMPS_INTERNAL

#include <rpmio.h>
#include <rpmtag.h>
#include <rpmdb.h>
#include <pkgio.h>
#include <rpmcb.h>
#include <rpmte.h>
#include <rpmps.h>
#include <rpmbuild.h>
#include <rpmgi.h>
#include <rpmlog.h>
#include <rpmconstant.h>

#include "xfile.h"

struct s_Package {
  char *info;
  int  filesize;
  char *requires;
  char *suggests;
  char *obsoletes;
  char *conflicts;
  char *provides;
  char *rflags;
  char *summary;
  unsigned flag;
  Header h;
};

struct s_Transaction {
  rpmts ts;
  int count;
};

struct s_TransactionData {
  SV* callback_open;
  SV* callback_close;
  SV* callback_trans;
  SV* callback_uninst;
  SV* callback_inst;
  long min_delta;
  SV *data; /* chain with another data user provided */
};

typedef struct s_Transaction* URPM__DB;
typedef struct s_Transaction* URPM__Transaction;
typedef struct s_Package* URPM__Package;

#define FLAG_ID               0x001fffffU
#define FLAG_RATE             0x00e00000U
#define FLAG_BASE             0x01000000U
#define FLAG_SKIP             0x02000000U
#define FLAG_DISABLE_OBSOLETE 0x04000000U
#define FLAG_INSTALLED        0x08000000U
#define FLAG_REQUESTED        0x10000000U
#define FLAG_REQUIRED         0x20000000U
#define FLAG_UPGRADE          0x40000000U
#define FLAG_NO_HEADER_FREE   0x80000000U

#define FLAG_ID_MAX           0x001ffffe
#define FLAG_ID_INVALID       0x001fffff

#define FLAG_RATE_POS         21
#define FLAG_RATE_MAX         5
#define FLAG_RATE_INVALID     0


#define FILTER_MODE_ALL_FILES     0
#define FILTER_MODE_CONF_FILES    2

static ssize_t
write_nocheck(int fd, const void *buf, size_t count) {
  return write(fd, buf, count);
}

static const void*
unused_variable(const void *p) {
  return p;
}

static int rpmError_callback_data;

static int
rpmError_callback() {
  write_nocheck(rpmError_callback_data, rpmlogMessage(), strlen(rpmlogMessage()));
  return RPMLOG_DEFAULT;
}

static int rpm_codeset_is_utf8 = 0;

static struct s_backup {
    char *ptr;
    char chr;
} char_backups[32];

static int BI = 0;

static void
backup_char(char *c) {
      char_backups[BI].chr = *c,
      *(char_backups[BI++].ptr = &(*c)) = 0; /* mark end of string to enable searching backwards */
}

static void
restore_chars() {
    for(; BI > 0; char_backups[BI].ptr = NULL)
	BI--, *char_backups[BI].ptr = char_backups[BI].chr;
}

static SV*
newSVpv_utf8(const char *s, STRLEN len)
{
  SV *sv = newSVpv(s, len);
  SvUTF8_on(sv);
  return sv;
}

/* XXX: RPMTAG_NVRA doesn't have disttag & distepoch */
#if 0
static const char *
get_nvra(Header header) {
  HE_t val = (HE_t)memset(alloca(sizeof(*val)), 0, sizeof(*val));

  val->tag = RPMTAG_NVRA;
  if(headerGet(header, val, 0))
    return val->p.str;
  return "";
}

#else

/* Since the NVRA format won't change, we'll store it in a global variable so
 * that we only have to expand the macro once.
 */
static const char *nvra_fmt = NULL;

static const char *
get_nvra_fmt() {
  if(!nvra_fmt) {
    char *qfmt = rpmExpand("%{?___NVRA:%___NVRA}%{?!___NVRA:/%_build_name_fmt}", NULL);
    /* On older rpm versions '%___NVRA' isn't defined, so then we'll have to create
     * it from the '%_build_name_fmt'
     */
    if(qfmt[0] == '/') {
      char *tmp;
      const char macroName[] = "___NVRA";
      if(strcasecmp(tmp = qfmt+strlen(qfmt)-4, ".rpm") == 0)   
	*tmp = '\0';
      tmp = qfmt;
      /* As %{ARCH} will be incorrect with source rpms, we replace it with a
       * conditional expression so that we get '.src.rpm' for source rpms.
       * This we'll do in a uhm.. "creative" way replacing '%{ARCH}' with '%{XXXX}',
       * which is a macro we'll define for the conditional expression,
       * when expanded it will return the format macro with the conditional
       * expression.
       */
      while((size_t)(tmp = strcasestr(tmp, "%{ARCH}")+2) != 2)while(*tmp != '}')
	*tmp++ = 'X';

      rpmDefineMacro(NULL, "XXXX %%|ARCH?{%%|SOURCERPM?{%%{ARCH}}:{src}|}:{}|", RMIL_DEFAULT);
      tmp = rpmExpand((tmp = strrchr(qfmt, '/')) ? tmp+1 : qfmt, NULL);

      qfmt = realloc(qfmt, strlen(tmp) + sizeof(macroName)+1);
      sprintf(qfmt, "%s %s", macroName, tmp);
      rpmDefineMacro(NULL, qfmt, RMIL_DEFAULT);
      sprintf(qfmt, "%s", qfmt+sizeof(macroName));
      _free(tmp);
    }
    nvra_fmt = qfmt;
  }
  return nvra_fmt;
}

static const char *
get_nvra(Header h) {
  const char *qfmt = get_nvra_fmt();
  const char *NVRA = headerSprintf(h, qfmt, NULL, NULL, NULL);
  return NVRA;
}

#endif

static int
do_rpmEVRcompare(const char *a, const char *b) {
  int compare;

  EVR_t lEVR = rpmEVRnew(RPMSENSE_EQUAL, 0),
        rEVR = rpmEVRnew(RPMSENSE_EQUAL, 0);
  rpmEVRparse(a, lEVR);
  rpmEVRparse(b, rEVR);
  compare = rpmEVRcompare(lEVR, rEVR);
  lEVR = rpmEVRfree(lEVR),
  rEVR = rpmEVRfree(rEVR);
  return compare;
}

static rpmTag
rpmtag_from_string(const char *tag)
{
  static rpmconst tag_c = NULL,
		  qv_c = NULL;
  static const char tag_context[] = "rpmtag",
		    qv_context[] = "rpmqvsources";
  /* XXX: rpmcli.h: @todo Reassign to tag values. */
  if (!strcmp(tag, "whatprovides"))
    return RPMTAG_PROVIDENAME;
  else if (!strcmp(tag, "whatrequires"))
    return RPMTAG_REQUIRENAME;
  else if (!strcmp(tag, "path"))
    return RPMTAG_BASENAMES;

  if(tag_c == NULL) {
    tag_c = rpmconstNew();
    if(!rpmconstInitToContext(tag_c, tag_context))
      croak("unknown context [%s]", tag_context);
  }
  if(rpmconstFindName(tag_c, tag, 0))
    return rpmconstValue(tag_c);
  if(qv_c == NULL) {
    qv_c = rpmconstNew();
    if(!rpmconstInitToContext(qv_c, qv_context))
      croak("unknown context [%s]", qv_context);
  }
  if(rpmconstFindName(qv_c, tag, 0))
    return rpmconstValue(qv_c);
  croak("unknown tag [%s]", tag);
}

static const char *
get_name(Header header, rpmTag tag) {
  HE_t val = (HE_t)memset(alloca(sizeof(*val)), 0, sizeof(*val));

  val->tag = tag;
  if(headerGet(header, val, 0)) {
    if (val->t == RPM_STRING_TYPE)
      return val->p.str;
    else if(val->t == RPM_STRING_ARRAY_TYPE || val->t == RPM_I18NSTRING_TYPE)
      return val->p.argv[val->ix];
  }
  return "";
}

static int
get_int(Header header, rpmTag tag) {
  HE_t val = (HE_t)memset(alloca(sizeof(*val)), 0, sizeof(*val));
  int ret = 0;

  val->tag = tag;
  if(headerGet(header, val, 0)) {
    ret = (val->t == RPM_UINT32_TYPE) ? val->p.ui32p[val->ix >= 0 ? val->ix : 0] : 0;
    val->p.ui32p = _free(val->p.ui32p);
  }
  return ret;
}

/* This function might modify strings that needs to be reverted after use
 * with restore_chars()
 */
static const char *
get_evr(URPM__Package pkg) {
    const char *evr = NULL;
    if(pkg->provides) {
      evr = strrchr(pkg->provides, ' ')+1;
      char *tmp = strrchr(evr, ']');
      if(tmp)
       backup_char(tmp);
    } else if(pkg->h) {
      HE_t val = (HE_t)memset(alloca(sizeof(*val)), 0, sizeof(*val));
      val->tag = RPMTAG_PROVIDEVERSION;
      headerGet(pkg->h, val, 0);
      evr =  val->p.argv[val->c-1];
    }
    return evr;
}

/* This function might modify strings that needs to be restored after use
 * with restore_chars()
 */
static void
get_fullname_parts_info(URPM__Package pkg, char **name, int *epoch, char **version, char **release, char **disttag, char **distepoch, char **arch, char **eos) {
  char *_version = NULL, *_release = NULL, *_disttag = NULL, *_distepoch = NULL, *_arch = NULL, *_eos = NULL, *tmp = NULL, *tmp2 = NULL;
  /* XXX: Could've probably be written in a more generic way, only thing we
   * really want to do is to check for arch field, which will be missing in
   * the case of gpg-pubkey at least..
   */
  int pubkey;

  if ((_eos = strchr(pkg->info, '@')) != NULL) {
    if (epoch != NULL) *epoch = isdigit(_eos[1]) ? atoi(_eos+1) : 0;
    if (name != NULL || version != NULL || release != NULL || disttag != NULL || distepoch != NULL || arch != NULL) {
      backup_char(_eos++);
      if (eos != NULL) *eos = _eos;
      if ((pubkey = !strncmp(pkg->info, "gpg-pubkey", 10)) || (_arch = strrchr(pkg->info, '.')) != NULL) {
	if (!pubkey)
	  backup_char(_arch++);
	if (arch != NULL) *arch = pubkey ? "" : _arch;
	if (distepoch != NULL || disttag != NULL || release != NULL || version != NULL || name != NULL) {
	  if ((_distepoch = strchr(strrchr(pkg->provides, '-'), ':')) != NULL) {
	    if ((tmp = strrchr(++_distepoch, ']'))) {
	      backup_char(tmp);
	      if ((tmp = strstr(pkg->info, _distepoch)))
		backup_char(tmp);
	      else {
		/* If synthesis is generated with older versions, disttag & distepoch will
		 * not be part of NVRA at beginning of line, but as it'll still be part of
		 * filename which is located at end of line, we can live with it as long
		 * as we're aware of it and take the necessary precautions to cope.
		 */
		if ((tmp = strrchr(_eos, '-'))) {
		  if ((tmp2 = strstr(tmp++, _distepoch))) {
		    backup_char(tmp2);
		    _disttag = tmp;
		  }
		}
	      }
	    }
	  }
	  if (distepoch != NULL) *distepoch = _distepoch ? _distepoch : "";
	  if (disttag != NULL || release != NULL || version != NULL || name != NULL) {
	    if (_disttag == NULL) {
	      /* XXX: re-verify this logic, see comment above.. */
	      if ((_disttag = strrchr(pkg->info, '-')) != NULL && (strstr(pkg->provides, _disttag)) == NULL) {
		backup_char(_disttag++);
	      } else _disttag = NULL;
	    }
	    if (disttag != NULL) *disttag = _disttag ? _disttag : "";
	    if ((release != NULL || version != NULL || name != NULL) && (_release = strrchr(pkg->info, '-')) != NULL) {
	      backup_char(_release++);
	      if (release != NULL) *release = _release;			  
	      if ((version != NULL || name != NULL) && (_version = strrchr(pkg->info, '-')) != NULL) {
		backup_char(_version++);
		if (version != NULL) *version = _version;
		if (name != NULL) *name = pkg->info;
	      }
	    }
	  }
	}
      }
    }
  }
}

static void
get_fullname_parts_header(Header h, char **name, int *epoch, char **version, char **release, char **disttag, char **distepoch, char **arch, char **eos) {
    if (name != NULL) *name = (char*)get_name(h, RPMTAG_NAME);
    if (epoch != NULL) *epoch = get_int(h, RPMTAG_EPOCH);
    if (version != NULL) *version = (char*)get_name(h, RPMTAG_VERSION);
    if (release != NULL) *release = (char*)get_name(h, RPMTAG_RELEASE);
    if (disttag != NULL) *disttag = (char*)get_name(h, RPMTAG_DISTTAG);
    if (distepoch != NULL) *distepoch = (char*)get_name(h, RPMTAG_DISTEPOCH);
    if (arch != NULL) *arch = headerIsEntry(h, RPMTAG_SOURCERPM) ? (char*)get_name(h, RPMTAG_ARCH) : "src";
    if (eos != NULL) *eos = NULL;
}

static int
get_fullname_parts(URPM__Package pkg, char **name, int *epoch, char **version, char **release, char **disttag, char **distepoch, char **arch, char **eos) {
  if(pkg->info)
    get_fullname_parts_info(pkg, name, epoch, version, release, disttag, distepoch, arch, eos);
  else if(pkg->h)
    get_fullname_parts_header(pkg->h, name, epoch, version, release, disttag, distepoch, arch, eos);
  else
    return 1;

  return 0;
}

static int
sigsize_to_filesize(int sigsize) {
  return sigsize + 440; /* 440 is the rpm header size (?) empirical, but works */
}

static int
print_list_entry(char *buff, int sz, const char *name, rpmsenseFlags flags, const char *evr) {
  int len = strlen(name);
  char *p = buff;

  if (len >= sz || !strncmp(name, "rpmlib(", 7)) return -1;
  memcpy(p, name, len); p += len;

  /* XXX: RPMSENSE_PREREQ obsolete, remove? */
  if (flags & (RPMSENSE_PREREQ|RPMSENSE_TRIGGER)) {
    if (p - buff + 3 >= sz) return -1;
    memcpy(p, "[*]", 4); p += 3;
  }
  if (evr != NULL) {
    len = strlen(evr);
    if (len > 0) {
      if (p - buff + 6 + len >= sz) return -1;
      static const char *Fstr[] = { "?0","<",">","?3","==","<=",">=","?7" };
      uint32_t Fx = ((flags >> 1) & 0x7);
      *p++ = '[';
      p = stpcpy( stpcpy( stpcpy(p, Fstr[Fx]), " "), evr);
      *p++ = ']';
    }
  }
  *p = 0; /* make sure to mark null char, Is it really necessary ? */

  return p - buff;
}

static int
ranges_overlap(rpmsenseFlags aflags, char *sa, rpmsenseFlags bflags, char *sb) {
  if (!aflags || !bflags)
    return 1; /* really faster to test it there instead of later */
  else {
    char *eosa = strchr(sa, ']');
    char *eosb = strchr(sb, ']');
    EVR_t lEVR = rpmEVRnew(aflags, 0),
          rEVR = rpmEVRnew(bflags, 0);
    int result;

    if(eosa) backup_char(eosa);
    if(eosb) backup_char(eosb);
    rpmEVRparse(sa, lEVR);
    rpmEVRparse(sb, rEVR);
    /* TODO: upstream bug? should rpmEVRparse really reset Flags? */
    lEVR->Flags = aflags;
    rEVR->Flags = bflags;
    result = rpmEVRoverlap(lEVR, rEVR);
    rpmEVRfree(lEVR);
    rpmEVRfree(rEVR);
    restore_chars();

    return result;
  }
}

static int has_old_suggests;
rpmsenseFlags is_old_suggests(rpmsenseFlags flags) { 
  rpmsenseFlags is = flags & RPMSENSE_MISSINGOK;
  if (is) has_old_suggests = is;
  return is;
}
rpmsenseFlags is_not_old_suggests(rpmsenseFlags flags) {
  return !is_old_suggests(flags);
}

typedef int (*callback_list_str)(char *s, int slen, const char *name, const rpmsenseFlags flags, const char *evr, void *param);

static int
callback_list_str_xpush(char *s, int slen, const char *name, rpmsenseFlags flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}
static int
callback_list_str_xpush_requires(char *s, int slen, const char *name, const rpmsenseFlags flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else if (is_not_old_suggests(flags)) {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}
static int
callback_list_str_xpush_old_suggests(char *s, int slen, const char *name, rpmsenseFlags flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else if (is_old_suggests(flags)) {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}

struct cb_overlap_s {
  char *name;
  rpmsenseFlags flags;
  char *evr;
  int direction; /* indicate to compare the above at left or right to the iteration element */
};

static int
callback_list_str_overlap(char *s, int slen, const char *name, rpmsenseFlags flags, const char *evr, void *param) {
  struct cb_overlap_s *os = (struct cb_overlap_s *)param;
  int result = 0;
  char *eos = NULL;
  char *eon = NULL;
  char eosc = '\0';
  char eonc = '\0';

  /* we need to extract name, flags and evr from a full sense information, store result in local copy */
  if (s) {
    if (slen) { eos = s + slen; eosc = *eos; *eos = 0; }
    name = s;
    while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
    if (*s) {
      eon = s;
      while (*s) {
	if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
	else if (*s == '<') flags |= RPMSENSE_LESS;
	else if (*s == '>') flags |= RPMSENSE_GREATER;
	else if (*s == '=') flags |= RPMSENSE_EQUAL;
	else break;
	++s;
      }
      evr = s;
    } else
      evr = "";
  }

  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* names should be equal, else it will not overlap */
  if (!strcmp(name, os->name)) {
    /* perform overlap according to direction needed, negative for left */
    if (os->direction < 0)
      result = ranges_overlap(os->flags, os->evr, flags, (char *) evr);
    else
      result = ranges_overlap(flags, (char *) evr, os->flags, os->evr);
  }

  /* fprintf(stderr, "cb_list_str_overlap result=%d, os->direction=%d, os->name=%s, os->evr=%s, name=%s, evr=%s\n",
     result, os->direction, os->name, os->evr, name, evr); */

  /* restore s if needed */
  if (eon) *eon = eonc;
  if (eos) *eos = eosc;

  return result;
}

static int
return_list_str(char *s, Header header, rpmTag tag_name, rpmTag tag_flags, rpmTag tag_version, callback_list_str f, void *param) {
  int count = 0;

  if (s != NULL) {
    char *ps = strchr(s, '@');
    if (tag_flags && tag_version) {
      while(ps != NULL) {
	++count;
	if (f(s, ps-s, NULL, 0, NULL, param)) return -count;
	s = ps + 1; ps = strchr(s, '@');
      }
      ++count;
      if (f(s, 0, NULL, 0, NULL, param)) return -count;
    } else {
      char *eos;
      while(ps != NULL) {
	*ps = 0; eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
	++count;
	if (f(s, eos ? eos-s : ps-s, NULL, 0, NULL, param)) { *ps = '@'; return -count; }
	*ps = '@'; /* restore in memory modified char */
	s = ps + 1; ps = strchr(s, '@');
      }
      eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
      ++count;
      if (f(s, eos ? eos-s : 0, NULL, 0, NULL, param)) return -count;
    }
  } else if (header) {
    HE_t list = memset(alloca(sizeof(*list)), 0, sizeof(*list));

    list->tag = tag_name;
    if (headerGet(header, list, 0)) {
      HE_t flags = memset(alloca(sizeof(*flags)), 0, sizeof(*flags));
      HE_t list_evr = memset(alloca(sizeof(*list_evr)), 0, sizeof(*list_evr));
      if (tag_flags) {
        flags->tag = tag_flags;
        headerGet(header, flags, 0);
      }
      if (tag_version) {
        list_evr->tag = tag_version;
        headerGet(header, list_evr, 0);
      }
      for (list->ix = 0; list->ix < (int)list->c; list->ix++) {
	++count;
	rpmsenseFlags *flag = (list->ix < (int)flags->c) ? (rpmsenseFlags*)flags->p.ui32p : NULL;
	if (f(NULL, 0, list->p.argv[list->ix], flag ? flag[list->ix] : 0, 
	      (list_evr->ix < (int)list_evr->c) ? list_evr->p.argv[list->ix] : NULL,
	      param)) {
	  list->p.ptr = _free(list->p.ptr);
	  if (tag_flags) flags->p.ui32p = _free(flags->p.ptr);
	  if (tag_version) list_evr->p.argv = _free(list_evr->p.ptr);
	  return -count;
	}
      }
      list->p.ptr = _free(list->p.ptr);
      if (tag_flags) flags->p.ptr = _free(flags->p.ptr);
      if (tag_version) list_evr->p.ptr = _free(list_evr->p.ptr);
    }
  }
  return count;
}

static int
xpush_simple_list_str(Header header, rpmTag tag_name) {
  dSP;
  if (header) {
    HE_t list = memset(alloca(sizeof(*list)), 0, sizeof(*list));

    list->tag = tag_name;
    if (!headerGet(header, list, 0)) return 0;

    for (list->ix = 0; list->ix < (int)list->c; list->ix++) {
        XPUSHs(sv_2mortal(newSVpv(list->p.argv[list->ix], 0)));
    }
    list->p.ptr = _free(list->p.ptr);
    PUTBACK;
    return list->c;
  } else return 0;
}

static void
return_list_int32_t(Header header, rpmTag tag_name) {
  dSP;
  if (header) {
    HE_t list = memset(alloca(sizeof(*list)), 0, sizeof(*list));

    list->tag = tag_name;
    if (headerGet(header, list, 0)) {
      for (list->ix = 0; list->ix < (int)list->c; list->ix++) {
	XPUSHs(sv_2mortal(newSViv(list->p.ui32p[list->ix])));
      }
      list->p.ptr = _free(list->p.ptr);
    }
  }
  PUTBACK;
}

static void
return_list_uint_16(Header header, rpmTag tag_name) {
  dSP;
  if (header) {
    HE_t list = memset(alloca(sizeof(*list)), 0, sizeof(*list));

    list->tag = tag_name;
    if (headerGet(header, list, 0)) {
      for(list->ix = 0; list->ix < (int)list->c; list->ix++) {
	XPUSHs(sv_2mortal(newSViv(list->p.ui16p[list->ix])));
      }
      list->p.ptr = _free(list->p.ptr);
    }
  }
  PUTBACK;
}

static void
return_list_tag_modifier(Header header, const char *tag_name) {
  dSP;
  HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));
  rpmTag tag = isdigit(*tag_name) ? (rpmTag)atoi(tag_name) : rpmtag_from_string(tag_name);

  he->tag = tag;
  if (!headerGet(header, he, 0)) return;

  for (he->ix = 0; he->ix < (int)he->c; he->ix++) {
    char buff[15];
    char *s = buff;
    rpmTagType tags = he->p.ui32p[he->ix];
    switch (tag) {
    case RPMTAG_FILEFLAGS:
      if (tags & RPMFILE_CONFIG)    *s++ = 'c';
      if (tags & RPMFILE_DOC)       *s++ = 'd';
      if (tags & RPMFILE_GHOST)     *s++ = 'g';
      if (tags & RPMFILE_LICENSE)   *s++ = 'l';
      if (tags & RPMFILE_MISSINGOK) *s++ = 'm';
      if (tags & RPMFILE_NOREPLACE) *s++ = 'n';
      if (tags & RPMFILE_SPECFILE)  *s++ = 'S';
      if (tags & RPMFILE_README)    *s++ = 'R';
      if (tags & RPMFILE_EXCLUDE)   *s++ = 'e';
      if (tags & RPMFILE_ICON)      *s++ = 'i';
      if (tags & RPMFILE_UNPATCHED) *s++ = 'u';
      if (tags & RPMFILE_PUBKEY)    *s++ = 'p';
    break;
    default:
      he->p.ptr = _free(he->p.ptr);
      return;  
    }
    *s = '\0';
    XPUSHs(sv_2mortal(newSVpv(buff, strlen(buff))));
  }
  he->p.ptr = _free(he->p.ptr);
  PUTBACK;
}

static void
return_list_tag(URPM__Package pkg, const char *tag_name) {
  dSP;
  rpmTag tag = isdigit(*tag_name) ? (rpmTag)atoi(tag_name) : rpmtag_from_string(tag_name);

  if (pkg->h != NULL) {
    HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));

    he->tag = tag;
    if (headerGet(pkg->h, he, 0)) {
      void *list = he->p.ptr;
      if (tag == RPMTAG_ARCH) {
	XPUSHs(sv_2mortal(newSVpv(headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? (char *) list : "src", 0)));
      } else
	switch (he->t) {
	  case RPM_UINT8_TYPE:
	  case RPM_UINT16_TYPE:
	  case RPM_UINT32_TYPE:
	    {
	      int *r = (int *)list;
	      for (he->ix=0; he->ix < (int)he->c; he->ix++) {
		XPUSHs(sv_2mortal(newSViv(r[he->ix])));
	      }
	    }
	    break;
	  case RPM_STRING_TYPE:
	    XPUSHs(sv_2mortal(newSVpv((char *) list, 0)));
	    break;
	  case RPM_BIN_TYPE:
	    break;
	  case RPM_STRING_ARRAY_TYPE:
	    {
	      const char **s = (const char **)list;
	      for (he->ix = 0; he->ix < (int)he->c; he->ix++) {
		XPUSHs(sv_2mortal(newSVpv(s[he->ix], 0)));
	      }
	    }
	    break;
	  case RPM_I18NSTRING_TYPE:
	    break;
	  case RPM_UINT64_TYPE:
	    break;
	}
      list = _free(list);
    }
  } else {
    char *name;
    int epoch;
    char *version;
    char *release;
    char *disttag;
    char *distepoch;

    char *arch;
    char *eos;
    switch (tag) {
      case RPMTAG_NAME:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  if(!strlen(name))
	    croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(name, 0)));
	}
	break;
      case RPMTAG_EPOCH: {
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  XPUSHs(sv_2mortal(newSViv(epoch)));
	}
      case RPMTAG_VERSION:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  if(!strlen(version))
	    croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(version, 0)));
	}
	break;
      case RPMTAG_RELEASE:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  if(!strlen(release))
	    croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(release, 0)));
	}
	break;
      case RPMTAG_DISTTAG:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  XPUSHs(sv_2mortal(newSVpv(disttag, 0)));
	}
	break;
      case RPMTAG_DISTEPOCH:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  XPUSHs(sv_2mortal(newSVpv(distepoch, 0)));
	}
	break;
      case RPMTAG_ARCH:
	{
	  get_fullname_parts_info(pkg, &name, &epoch, &version, &release, &arch, &disttag, &distepoch, &eos);
	  XPUSHs(sv_2mortal(newSVpv(arch, 0)));
	}
	break;
      case RPMTAG_SUMMARY:
	XPUSHs(sv_2mortal(newSVpv(pkg->summary, 0)));
	break;
      default:
	croak("unexpected tag");
	break;
    }
    restore_chars();
  }
  PUTBACK;
}


static void
return_files(Header header, int filter_mode) {
  dSP;
  if (header) {
    const char *s;
    STRLEN len;

    const char **list = NULL;
    HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));
    rpmsenseFlags *flags = NULL;
    if (filter_mode) {
      he->tag = RPMTAG_FILEFLAGS;
      if(headerGet(header, he, 0))
	flags = (rpmsenseFlags*)he->p.ui32p;

    }

    he->tag = RPMTAG_FILEPATHS;
    if (!headerGet(header, he, 0)) return;
    list = he->p.argv;

    for(he->ix = 0; he->ix < (int)he->c; he->ix++) {
      s = list[he->ix];
      len = strlen(list[he->ix]);

      if (filter_mode) {
	if ((filter_mode & FILTER_MODE_CONF_FILES) && flags && (flags[he->ix] & RPMFILE_CONFIG) == 0) continue;
      }

      XPUSHs(sv_2mortal(newSVpv(s, len)));
    }
    flags = _free(flags);
    list = _free(list);
  }
  PUTBACK;
}

static void
return_problems(rpmps ps, int translate_message, int raw_message) {
  dSP;
  if (ps && rpmpsNumProblems(ps) > 0) {
    rpmpsi iterator = rpmpsInitIterator(ps);
    while (rpmpsNextIterator(iterator) >= 0) {
      rpmProblem p = rpmpsGetProblem(iterator->ps, iterator->ix);

      if (translate_message) {
	/* translate error using rpm localization */
	const char *buf = rpmProblemString(p);
	SV *sv = newSVpv(buf, 0);
	if (rpm_codeset_is_utf8) SvUTF8_on(sv);
	XPUSHs(sv_2mortal(sv));
	_free(buf);
      }
      if (raw_message) {
	const char *pkgNEVR = rpmProblemGetPkgNEVR(p) ? rpmProblemGetPkgNEVR(p) : "";
	const char *altNEVR = rpmProblemGetAltNEVR(p) ? rpmProblemGetAltNEVR(p) : "";
	const char *s = rpmProblemGetStr(p) ? rpmProblemGetStr(p) : "";
	SV *sv;

	switch (rpmProblemGetType(p)) {
	case RPMPROB_BADARCH:
	  sv = newSVpvf("badarch@%s", pkgNEVR); break;

	case RPMPROB_BADOS:
	  sv = newSVpvf("bados@%s", pkgNEVR); break;

	case RPMPROB_PKG_INSTALLED:
	  sv = newSVpvf("installed@%s", pkgNEVR); break;

	case RPMPROB_BADRELOCATE:
	  sv = newSVpvf("badrelocate@%s@%s", pkgNEVR, s); break;

	case RPMPROB_NEW_FILE_CONFLICT:
	case RPMPROB_FILE_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s@%s", pkgNEVR, altNEVR, s); break;

	case RPMPROB_OLDPACKAGE:
	  sv = newSVpvf("installed@%s@%s", pkgNEVR, altNEVR); break;

	case RPMPROB_DISKSPACE:
	  sv = newSVpvf("diskspace@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_DISKNODES:
	  sv = newSVpvf("disknodes@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_REQUIRES:
	  sv = newSVpvf("requires@%s@%s", pkgNEVR, altNEVR+2); break;

	case RPMPROB_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s", pkgNEVR, altNEVR+2); break;

	default:
	  sv = newSVpvf("unknown@%s", pkgNEVR); break;
	}
	XPUSHs(sv_2mortal(sv));
      }
    }
    rpmpsFreeIterator(iterator);
  }
  PUTBACK;
}

static char *
pack_list(Header header, rpmTag tag_name, rpmTag tag_flags, rpmTag tag_version, rpmsenseFlags (*check_flag)(rpmsenseFlags)) {
  char buff[65536];
  rpmsenseFlags *flags = NULL;
  const char **list_evr = NULL;
  char *p = buff;
  HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));

  he->tag = tag_name;
  if (headerGet(header, he, 0)) {
    const char **list = he->p.argv;
   
    if (tag_flags) {
      HE_t he_flags = memset(alloca(sizeof(*he_flags)), 0, sizeof(*he_flags));
      he_flags->tag = tag_flags;
      if(headerGet(header, he_flags, 0))
	flags = (rpmsenseFlags*)he_flags->p.ui32p;
    }
    if (tag_version) {
      HE_t he_list_evr = memset(alloca(sizeof(*he_list_evr)), 0, sizeof(*he_list_evr));
      he_list_evr->tag = tag_version;
      if(headerGet(header, he_list_evr, 0))
	list_evr = he_list_evr->p.argv;
    }
    for(he->ix = 0; he->ix < (int)he->c; he->ix++) {
      if (check_flag && !check_flag(flags[he->ix])) continue;
      int len = print_list_entry(p, sizeof(buff)-(p-buff)-1, list[he->ix], flags ? flags[he->ix] : 0, list_evr ? list_evr[he->ix] : NULL);
      if (len < 0) continue;
      p += len;
      *p++ = '@';
    }
    if (p > buff) p[-1] = 0;

    flags = _free(flags);
    list = _free(list);
    list_evr = _free(list_evr);
  }

  return p > buff ? memcpy(malloc(p-buff), buff, p-buff) : NULL;
}

static void
pack_header(URPM__Package pkg) {
  if (pkg->h) {
    if (pkg->info == NULL) {
      char buff[1024];
      char *p = buff;
      const char *group = get_name(pkg->h, RPMTAG_GROUP);
      const char *nvra = get_nvra(pkg->h);
      p += 1 + snprintf(buff, sizeof(buff), "%s@%d@%d@%s", nvra,
		    get_int(pkg->h, RPMTAG_EPOCH), get_int(pkg->h, RPMTAG_SIZE), 
		    group);
      pkg->info = memcpy(malloc(p-buff), buff, p-buff);
      _free(group);
      _free(nvra);
    }
    if (pkg->filesize == 0) pkg->filesize = sigsize_to_filesize(get_int(pkg->h, RPMTAG_SIGSIZE));
    if (pkg->requires == NULL && pkg->suggests == NULL)
      has_old_suggests = 0;
      pkg->requires = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION, is_not_old_suggests);
      if (has_old_suggests)
      pkg->suggests = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION, is_old_suggests);
      else
        pkg->suggests = pack_list(pkg->h, RPMTAG_SUGGESTSNAME, 0, 0, NULL);
    if (pkg->obsoletes == NULL)
      pkg->obsoletes = pack_list(pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION, NULL);
    if (pkg->conflicts == NULL)
      pkg->conflicts = pack_list(pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION, NULL);
    if (pkg->provides == NULL)
      pkg->provides = pack_list(pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION, NULL);
    if (pkg->summary == NULL) {
      const char *summary = get_name(pkg->h, RPMTAG_SUMMARY);
      pkg->summary = (char*)summary;
    }

    if (!(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h =headerFree(pkg->h);
    pkg->h = 0;
  }
}

static void
update_hash_entry(HV *hash, const char *name, STRLEN len, int force, IV use_sense, URPM__Package pkg) {
  SV** isv;

  if (!len) len = strlen(name);
  if ((isv = hv_fetch(hash, name, len, force))) {
    /* check if an entry has been found or created, it should so be updated */
    if (!SvROK(*isv) || SvTYPE(SvRV(*isv)) != SVt_PVHV) {
      SV* choice_set = (SV*)newHV();
      if (choice_set) {
	SvREFCNT_dec(*isv); /* drop the old as we are changing it */
	if (!(*isv = newRV_noinc(choice_set))) {
	  SvREFCNT_dec(choice_set);
	  *isv = &PL_sv_undef;
	}
      }
    }
    if (isv && *isv != &PL_sv_undef) {
      char id[8];
      STRLEN id_len = snprintf(id, sizeof(id), "%d", pkg->flag & FLAG_ID);
      SV **sense = hv_fetch((HV*)SvRV(*isv), id, id_len, 1);
      if (sense && use_sense) sv_setiv(*sense, use_sense);
    }
  }
}

static void
update_provide_entry(const char *name, STRLEN len, int force, IV use_sense, URPM__Package pkg, HV *provides) {
  update_hash_entry(provides, name, len, force, use_sense, pkg);
}

static void
update_provides(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    int len;
    HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));
    rpmsenseFlags *flags = NULL;

    /* examine requires for files which need to be marked in provides */
    he->tag = RPMTAG_REQUIRENAME;
    if (headerGet(pkg->h, he, 0)) {
      const char **list = he->p.argv;
      for (he->ix = 0; he->ix < (int)he->c; he->ix++) {
	len = strlen(list[he->ix]);
	if (list[he->ix][0] == '/') (void)hv_fetch(provides, list[he->ix], len, 1);
      }
      list = _free(list);
    }

    /* update all provides */
    he->tag = RPMTAG_PROVIDENAME;
    if (headerGet(pkg->h, he, 0)) {
      const char **list = he->p.argv;

      he->tag = RPMTAG_PROVIDEFLAGS;
      if (headerGet(pkg->h, he, 0)) {
        HE_t he_flags = memset(alloca(sizeof(*he_flags)), 0, sizeof(*he_flags));
	flags = (rpmsenseFlags*)he_flags->p.ui32p;
      }
      for (he->ix = 0; he->ix < (int)he->c; he->ix++) {
	len = strlen(list[he->ix]);
	update_provide_entry(list[he->ix], len, 1, flags && flags[he->ix] & (RPMSENSE_PREREQ|RPMSENSE_TRIGGER),
	    pkg, provides);
      }
      flags = _free(flags);
      list = _free(list);
    }
  } else {
    char *ps, *s, *es;

    if ((s = pkg->requires) != NULL && *s != 0) {
      ps = strchr(s, '@');
      while(ps != NULL) {
	if (s[0] == '/') {
	  *ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	  (void)hv_fetch(provides, s, es != NULL ? es-s : ps-s, 1);
	}
	s = ps + 1; ps = strchr(s, '@');
      }
      if (s[0] == '/') {
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
	(void)hv_fetch(provides, s, es != NULL ? (U32)(es-s) : strlen(s), 1);
      }
    }

    if ((s = pkg->provides) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_provide_entry(s, es != NULL ? es-s : ps-s, 1, es != NULL, pkg, provides);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_provide_entry(s, es != NULL ? es-s : 0, 1, es != NULL, pkg, provides);
    }
  }
}

static void
update_obsoletes(URPM__Package pkg, HV *obsoletes) {
  if (pkg->h) {
    HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));

    /* update all provides */
    he->tag = RPMTAG_OBSOLETENAME;
    if (headerGet(pkg->h, he, 0)) {
      const char **list = he->p.argv;
      for (he->ix = 0; he->ix < (int)he->c; he->ix++)
	update_hash_entry(obsoletes, list[he->ix], 0, 1, 0, pkg);
    }
  } else {
    char *ps, *s;

    if ((s = pkg->obsoletes) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_hash_entry(obsoletes, s, es != NULL ? es-s : ps-s, 1, 0, pkg);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_hash_entry(obsoletes, s, es != NULL ? es-s : 0, 1, 0, pkg);
    }
  }
}

static void
update_provides_files(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    STRLEN len;
    const char **list = NULL;
    HE_t he = memset(alloca(sizeof(*he)), 0, sizeof(*he));

    he->tag = RPMTAG_FILEPATHS;
    if(headerGet(pkg->h, he, 0)) {
      list = he->p.argv;
      for (he->ix = 0; he->ix < (int)he->c; he->ix++) {
	len = strlen(list[he->ix]);

	update_provide_entry(list[he->ix], len, 0, 0, pkg, provides);
      }

      list = _free(list);
    }
  }
}

static int
open_archive(char *filename, pid_t *pid, int *empty_archive) {
  int fd;
  struct {
    char header[4];
    char toc_d_count[4];
    char toc_l_count[4];
    char toc_f_count[4];
    char toc_str_size[4];
    char uncompress[40];
    char trailer[4];
  } buf;

  fd = open(filename, O_RDONLY);
  if (fd >= 0) {
    int pos = lseek(fd, -(int)sizeof(buf), SEEK_END);
    if (read(fd, &buf, sizeof(buf)) != sizeof(buf) || strncmp(buf.header, "cz[0", 4) || strncmp(buf.trailer, "0]cz", 4)) {
      /* this is not an archive, open it without magic, but first rewind at begin of file */
      lseek(fd, 0, SEEK_SET);
    } else if (pos == 0) {
      *empty_archive = 1;
      fd = -1;
    } else {
      /* this is an archive, create a pipe and fork for reading with uncompress defined inside */
      int fdno[2];

      if (!pipe(fdno)) {
	if ((*pid = fork()) != 0) {
	  fd_set readfds;
	  struct timeval timeout;

	  FD_ZERO(&readfds);
	  FD_SET(fdno[0], &readfds);
	  timeout.tv_sec = 1;
	  timeout.tv_usec = 0;
	  select(fdno[0]+1, &readfds, NULL, NULL, &timeout);

	  close(fd);
	  fd = fdno[0];
	  close(fdno[1]);
	} else {
	  char *unpacker[22]; /* enough for 40 bytes in uncompress to never overbuf */
	  char *p = buf.uncompress;
	  int ip = 0;
	  char *ld_loader = getenv("LD_LOADER");

	  if (ld_loader && *ld_loader) {
	    unpacker[ip++] = ld_loader;
	  }

	  buf.trailer[0] = 0; /* make sure end-of-string is right */
	  while (*p) {
	    if (*p == ' ' || *p == '\t') *p++ = 0;
	    else {
	      unpacker[ip++] = p;
	      while (*p && *p != ' ' && *p != '\t') ++p;
	    }
	  }
	  unpacker[ip] = NULL; /* needed for execlp */

	  lseek(fd, 0, SEEK_SET);
	  dup2(fd, STDIN_FILENO); close(fd);
	  dup2(fdno[1], STDOUT_FILENO); close(fdno[1]);

	  /* get rid of "decompression OK, trailing garbage ignored" */
	  fd = open("/dev/null", O_WRONLY);
	  dup2(fd, STDERR_FILENO); close(fd);

	  execvp(unpacker[0], unpacker);
	  exit(1);
	}
      } else {
	close(fd);
	fd = -1;
      }
    }
  }
  return fd;
}

static int
call_package_callback(SV *urpm, SV *sv_pkg, SV *callback) {
  if (sv_pkg != NULL && callback != NULL) {
    int count;

    /* now, a callback will be called for sure */
    dSP;
    PUSHMARK(SP);
    XPUSHs(urpm);
    XPUSHs(sv_pkg);
    PUTBACK;
    count = call_sv(callback, G_SCALAR);
    SPAGAIN;
    if (count == 1 && !POPi) {
      /* package should not be added in depslist, so we free it */
      SvREFCNT_dec(sv_pkg);
      sv_pkg = NULL;
    }
    PUTBACK;
  }

  return sv_pkg != NULL;
}

static int
parse_line(AV *depslist, HV *provides, HV *obsoletes, URPM__Package pkg, char *buff, SV *urpm, SV *callback) {
  SV *sv_pkg;
  URPM__Package _pkg;
  char *tag, *data;
  int data_len;

  if (buff[0] == 0) {
    return 1;
  } else if ((tag = buff)[0] == '@' && (data = strchr(tag+1, '@')) != NULL) {
    *tag++ = *data++ = 0;
    data_len = 1+strlen(data);
    if (!strcmp(tag, "info")) {
      pkg->info = memcpy(malloc(data_len), data, data_len);
      pkg->flag &= ~FLAG_ID;
      pkg->flag |= 1 + av_len(depslist);
      sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
			    _pkg = memcpy(malloc(sizeof(struct s_Package)), pkg, sizeof(struct s_Package)));
      if (call_package_callback(urpm, sv_pkg, callback)) {
	if (provides) update_provides(_pkg, provides);
	if (obsoletes) update_obsoletes(_pkg, obsoletes);
	av_push(depslist, sv_pkg);
      }
      memset(pkg, 0, sizeof(struct s_Package));
    } else if (!strcmp(tag, "filesize")) {
      pkg->filesize = atoi(data);
    } else if (!strcmp(tag, "requires")) {
      free(pkg->requires); pkg->requires = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "suggests")) {
      free(pkg->suggests); pkg->suggests = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "obsoletes")) {
      free(pkg->obsoletes); pkg->obsoletes = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "conflicts")) {
      free(pkg->conflicts); pkg->conflicts = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "provides")) {
      free(pkg->provides); pkg->provides = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "summary")) {
      free(pkg->summary); pkg->summary = memcpy(malloc(data_len), data, data_len);
    }
    return 1;
  } else {
    fprintf(stderr, "bad line <%s>\n", buff);
    return 0;
  }
}

#if 0
static void pack_rpm_header(Header *h) {
  Header packed = headerNew();

  HeaderIterator hi = headerInitIterator(*h);
  struct rpmtd_s td;
  while (headerNext(hi, &td)) {
      // fprintf(stderr, "adding %s %d\n", tagname(tag), c);
      headerPut(packed, &td, HEADERPUT_DEFAULT);
      rpmtdFreeData(&td);
  }

  headerFreeIterator(hi);
  *h = headerFree(*h);

  *h = packed;
}

static void drop_tags(Header *h) {
  headerDel(*h, RPMTAG_FILEUSERNAME); /* user ownership is correct */
  headerDel(*h, RPMTAG_FILEGROUPNAME); /* group ownership is correct */
  headerDel(*h, RPMTAG_FILEMTIMES); /* correct time without it */
  headerDel(*h, RPMTAG_FILEINODES); /* hardlinks work without it */
  headerDel(*h, RPMTAG_FILEDEVICES); /* it is the same number for every file */
  headerDel(*h, RPMTAG_FILESIZES); /* ? */
  headerDel(*h, RPMTAG_FILERDEVS); /* it seems unused. always empty */
  headerDel(*h, RPMTAG_FILEVERIFYFLAGS); /* only used for -V */
  headerDel(*h, RPMTAG_FILEDIGESTALGOS); /* only used for -V */
  headerDel(*h, RPMTAG_FILEDIGESTS); /* only used for -V */ /* alias: RPMTAG_FILEMD5S */ 
  /* keep RPMTAG_FILEFLAGS for %config (rpmnew) to work */
  /* keep RPMTAG_FILELANGS for %lang (_install_langs) to work */
  /* keep RPMTAG_FILELINKTOS for checking conflicts between symlinks */
  /* keep RPMTAG_FILEMODES otherwise it segfaults with excludepath */

  /* keep RPMTAG_POSTIN RPMTAG_POSTUN RPMTAG_PREIN RPMTAG_PREUN */
  /* keep RPMTAG_TRIGGERSCRIPTS RPMTAG_TRIGGERVERSION RPMTAG_TRIGGERFLAGS RPMTAG_TRIGGERNAME */
  /* small enough, and only in some packages. not needed per se */

  headerDel(*h, RPMTAG_ICON);
  headerDel(*h, RPMTAG_GIF);
  headerDel(*h, RPMTAG_EXCLUDE);
  headerDel(*h, RPMTAG_EXCLUSIVE);
  headerDel(*h, RPMTAG_COOKIE);
  headerDel(*h, RPMTAG_VERIFYSCRIPT);

  /* always the same for our packages */
  headerDel(*h, RPMTAG_VENDOR);
  headerDel(*h, RPMTAG_DISTRIBUTION);

  /* keep RPMTAG_SIGSIZE, useful to tell the size of the rpm file (+440) */

  headerDel(*h, RPMTAG_DSAHEADER);
  headerDel(*h, RPMTAG_SHA1HEADER);
  headerDel(*h, RPMTAG_SIGMD5);
  headerDel(*h, RPMTAG_SIGGPG);

  pack_rpm_header(h);
}
#endif

static int
update_header(char *filename, URPM__Package pkg, __attribute__((unused)) int keep_all_tags, int vsflags) {
  int d = open(filename, O_RDONLY);

  if (d >= 0) {
    unsigned char sig[4];

    if (read(d, &sig, sizeof(sig)) == sizeof(sig)) {
      lseek(d, 0, SEEK_SET);
      if (sig[0] == 0xed && sig[1] == 0xab && sig[2] == 0xee && sig[3] == 0xdb) {
	FD_t fd = fdDup(d);
	Header header;
	rpmts ts;

	close(d);
	ts = rpmtsCreate();
	rpmtsSetVSFlags(ts, _RPMVSF_NOSIGNATURES | vsflags);
	if (fd != NULL && rpmReadPackageFile(ts, fd, filename, &header) == 0 && header) {
	  char *basename;
	  struct stat sb;

	  basename = strrchr(filename, '/');
	  Fstat(fd, &sb);
	  Fclose(fd);

	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
	  pkg->h = header;
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;

	  /*if (!keep_all_tags) drop_tags(&pkg->h);*/
	  (void)rpmtsFree(ts);
	  return 1;
	}
	(void)rpmtsFree(ts);
      } else if (sig[0] == 0x8e && sig[1] == 0xad && sig[2] == 0xe8 && sig[3] == 0x01) {
	FD_t fd = fdDup(d);

	close(d);
	if (fd != NULL) {
	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
	  const char item[] = "Header";
	  const char * msg = NULL;
	  rpmRC rc = rpmpkgRead(item, fd, &pkg->h, &msg);

	  switch (rc) {
	  default:
	    rpmlog(RPMLOG_ERR, "%s: %s: %s\n", "rpmpkgRead", item, msg);
	  case RPMRC_NOTFOUND:
	      pkg->h = NULL;
	  case RPMRC_OK:
	    break;
	  }
	  msg = (const char*)_free(msg);

	  pkg->flag &= ~FLAG_NO_HEADER_FREE;
	  Fclose(fd);
	  return 1;
	}
      }
    }
  }
  return 0;
}

static int
read_config_files(int force) {
  static int already = 0;
  int rc = 0;

  if (!already || force) {
    rc = rpmReadConfigFiles(NULL, NULL);
    already = (rc == 0); /* set config as load only if it succeed */
  }
  return rc;
}

static void
ts_nosignature(rpmts ts) {
  rpmtsSetVSFlags(ts, _RPMVSF_NODIGESTS | _RPMVSF_NOSIGNATURES);
}

static void *
rpmRunTransactions_callback(__attribute__((unused)) const void *h,
					 const rpmCallbackType what, 
					 const rpmuint64_t amount, 
					 const rpmuint64_t total,
					 fnpyKey pkgKey,
					 rpmCallbackData data) {
  static struct timeval tprev;
  static struct timeval tcurr;
  static FD_t fd = NULL;
  long delta;
  int i;
  struct s_TransactionData *td = data;
  SV *callback = NULL;
  char *callback_type = NULL;
  char *callback_subtype = NULL;

  if (!td)
    return NULL;

  switch (what) {
    case RPMCALLBACK_INST_OPEN_FILE:
      callback = td->callback_open;
      callback_type = "open";
      break;
    case RPMCALLBACK_INST_CLOSE_FILE:
      callback = td->callback_close;
      callback_type = "close";
      break;
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_TRANS_STOP:
      callback = td->callback_trans;
      callback_type = "trans";
      break;
    case RPMCALLBACK_UNINST_START:
    case RPMCALLBACK_UNINST_PROGRESS:
    case RPMCALLBACK_UNINST_STOP:
      callback = td->callback_uninst;
      callback_type = "uninst";
      break;
    case RPMCALLBACK_INST_START:
    case RPMCALLBACK_INST_PROGRESS:
      callback = td->callback_inst;
      callback_type = "inst";
      break;
    default:
      break;
  }

  if (callback != NULL) {
    switch (what) {
      case RPMCALLBACK_TRANS_START:
      case RPMCALLBACK_UNINST_START:
      case RPMCALLBACK_INST_START:
	callback_subtype = "start";
	gettimeofday(&tprev, NULL);
	break;
      case RPMCALLBACK_TRANS_PROGRESS:
      case RPMCALLBACK_UNINST_PROGRESS:
      case RPMCALLBACK_INST_PROGRESS:
	callback_subtype = "progress";
	gettimeofday(&tcurr, NULL);
	delta = 1000000 * (tcurr.tv_sec - tprev.tv_sec) + (tcurr.tv_usec - tprev.tv_usec);
	if (delta < td->min_delta && amount < total - 1)
	  callback = NULL; /* avoid calling too often a given callback */
	else
	  tprev = tcurr;
	break;
      case RPMCALLBACK_TRANS_STOP:
      case RPMCALLBACK_UNINST_STOP:
	callback_subtype = "stop";
	break;
      default:
	break;
    }

    if (callback != NULL) {
      /* now, a callback will be called for sure */
      dSP;
      ENTER;
      SAVETMPS;
      PUSHMARK(SP);
      XPUSHs(td->data);
      XPUSHs(sv_2mortal(newSVpv(callback_type, 0)));
      XPUSHs(pkgKey != NULL ? sv_2mortal(newSViv((long)pkgKey - 1)) : &PL_sv_undef);
      if (callback_subtype != NULL) {
	XPUSHs(sv_2mortal(newSVpv(callback_subtype, 0)));
	XPUSHs(sv_2mortal(newSViv(amount)));
	XPUSHs(sv_2mortal(newSViv(total)));
      }
      PUTBACK;
      i = call_sv(callback, callback == td->callback_open ? G_SCALAR : G_DISCARD);
      SPAGAIN;
      if (callback == td->callback_open) {
	if (i != 1) croak("callback_open should return a file handle");
	i = POPi;
	fd = fdDup(i);
	if (fd) {
	  fd = fdLink(fd, "persist perl-URPM");
	  Fcntl(fd, F_SETFD, (void *)1); /* necessary to avoid forked/execed process to lock removable */
	}
	PUTBACK;
      } else if (callback == td->callback_close) {
	fd = fdFree(fd, "persist perl-URPM");
	if (fd) {
	  Fclose(fd);
	  fd = NULL;
	}
      }
      FREETMPS;
      LEAVE;
    }
  }
  return callback == td->callback_open ? fd : NULL;
}

#line 1592 "URPM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 1644 "URPM.c"

XS(XS_URPM__Package_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::Package::DESTROY",
			"pkg");
#line 1588 "URPM.xs"
  free(pkg->info);
  free(pkg->requires);
  free(pkg->suggests);
  free(pkg->obsoletes);
  free(pkg->conflicts);
  free(pkg->provides);
  free(pkg->rflags);
  free(pkg->summary);
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
  free(pkg);
#line 1678 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::name",
			"pkg", "URPM::Package");
#line 1603 "URPM.xs"
  char *name;
#line 1709 "URPM.c"
#line 1605 "URPM.xs"
  if(get_fullname_parts(pkg, &name, NULL, NULL, NULL, NULL, NULL, NULL, NULL))
    croak("invalid fullname");
  XPUSHs(sv_2mortal(newSVpv(name, 0)));
  restore_chars();
#line 1715 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::version",
			"pkg", "URPM::Package");
#line 1614 "URPM.xs"
  char *version;
#line 1747 "URPM.c"
#line 1616 "URPM.xs"
  if(get_fullname_parts(pkg, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL))
    croak("invalid fullname");
  XPUSHs(sv_2mortal(newSVpv(version, 0)));
  restore_chars();
#line 1753 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_release); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_release)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::release",
			"pkg", "URPM::Package");
#line 1625 "URPM.xs"
  char *release;
#line 1785 "URPM.c"
#line 1627 "URPM.xs"
  if(get_fullname_parts(pkg, NULL, NULL, NULL, &release, NULL, NULL, NULL, NULL))
    croak("invalid fullname");
  XPUSHs(sv_2mortal(newSVpv(release, 0)));
  restore_chars();
#line 1791 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_disttag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_disttag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::disttag",
			"pkg", "URPM::Package");
#line 1635 "URPM.xs"
  char *disttag;
#line 1823 "URPM.c"
#line 1637 "URPM.xs"
  if(get_fullname_parts(pkg, NULL, NULL, NULL, NULL, &disttag, NULL, NULL, NULL))
    croak("invalid fullname");
  XPUSHs(sv_2mortal(newSVpv(disttag, 0)));
  restore_chars();
#line 1829 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_distepoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_distepoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::distepoch",
			"pkg", "URPM::Package");
#line 1645 "URPM.xs"
  char *distepoch;
#line 1861 "URPM.c"
#line 1647 "URPM.xs"
  if(get_fullname_parts(pkg, NULL, NULL, NULL, NULL, NULL, &distepoch, NULL, NULL))
    croak("invalid fullname");
  XPUSHs(sv_2mortal(newSVpv(distepoch, 0)));
  restore_chars();
#line 1867 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_arch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_arch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::arch",
			"pkg", "URPM::Package");
#line 1656 "URPM.xs"
  char *arch;
#line 1899 "URPM.c"
#line 1659 "URPM.xs"
  get_fullname_parts(pkg, NULL, NULL, NULL, NULL, NULL, NULL, &arch, NULL);
  XPUSHs(sv_2mortal(newSVpv(arch, 0)));
  restore_chars();
#line 1904 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_is_arch_compat__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_is_arch_compat__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::is_arch_compat__XS",
			"pkg", "URPM::Package");
#line 1667 "URPM.xs"
  const char * platform;
#line 1936 "URPM.c"
#line 1669 "URPM.xs"
  read_config_files(0);
  if (pkg->info) {
    char *arch;

    get_fullname_parts(pkg, NULL, NULL, NULL, NULL, NULL, NULL, &arch, NULL);
    platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    _free(platform);
    restore_chars();
  } else if (pkg->h && headerIsEntry(pkg->h, RPMTAG_SOURCERPM)) {
    const char *arch = get_name(pkg->h, RPMTAG_ARCH);
    platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    _free(arch);
    _free(platform);
  } else {
    RETVAL = 0;
  }
#line 1956 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_is_platform_compat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_is_platform_compat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::is_platform_compat",
			"pkg", "URPM::Package");
#line 1694 "URPM.xs"
  const char * platform = NULL;
  HE_t val = memset(alloca(sizeof(*val)), 0, sizeof(*val));

#line 1990 "URPM.c"
#line 1698 "URPM.xs"
  read_config_files(0);
  RETVAL = 0;
  if (pkg->h && headerIsEntry(pkg->h, RPMTAG_PLATFORM)) {
    val->tag = RPMTAG_PLATFORM;
    if(headerGet(pkg->h, val, 0)) {
      platform = val->p.str;
      RETVAL = rpmPlatformScore(platform, NULL, 0);
      platform = _free(platform);
    }
  } else if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, NULL, NULL, NULL, &arch, &eos);
    platform = rpmExpand(arch, "-%{_target_vendor}-", eos, "%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    restore_chars();
    _free(platform);
  }

#line 2012 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_summary); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_summary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::summary",
			"pkg", "URPM::Package");
#line 1725 "URPM.xs"
  if (pkg->summary) {
    XPUSHs(sv_2mortal(newSVpv_utf8(pkg->summary, 0)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_SUMMARY), 0)));
  }
#line 2048 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::description",
			"pkg", "URPM::Package");
#line 1735 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_DESCRIPTION), 0)));
  }
#line 2082 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_sourcerpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_sourcerpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::sourcerpm",
			"pkg", "URPM::Package");
#line 1743 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_SOURCERPM), 0)));
  }
#line 2116 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_packager); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_packager)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::packager",
			"pkg", "URPM::Package");
#line 1751 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_PACKAGER), 0)));
  }
#line 2150 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildhost); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildhost)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildhost",
			"pkg", "URPM::Package");
#line 1759 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_BUILDHOST), 0)));
  }
#line 2184 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildtime",
			"pkg", "URPM::Package");
#line 1767 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_BUILDTIME);
  } else {
    RETVAL = 0;
  }
#line 2220 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_installtid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_installtid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::installtid",
			"pkg", "URPM::Package");
#line 1779 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_INSTALLTID);
  } else {
    RETVAL = 0;
  }
#line 2256 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_url); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_url)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::url",
			"pkg", "URPM::Package");
#line 1791 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_URL), 0)));
  }
#line 2290 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_license); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_license)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::license",
			"pkg", "URPM::Package");
#line 1799 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_LICENSE), 0)));
  }
#line 2324 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_distribution); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_distribution)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::distribution",
			"pkg", "URPM::Package");
#line 1807 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_DISTRIBUTION), 0)));
  }
#line 2358 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_vendor); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_vendor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::vendor",
			"pkg", "URPM::Package");
#line 1815 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_VENDOR), 0)));
  }
#line 2392 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_os); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_os)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::os",
			"pkg", "URPM::Package");
#line 1823 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_OS), 0)));
  }
#line 2426 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_payload_format); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_payload_format)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::payload_format",
			"pkg", "URPM::Package");
#line 1831 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_PAYLOADFORMAT), 0)));
  }
#line 2460 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_evr); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_evr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 1839 "URPM.xs"
  const char *evr;
#line 2483 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::evr",
			"pkg", "URPM::Package");
#line 1841 "URPM.xs"
  evr = get_evr(pkg);
  XPUSHs(sv_2mortal(newSVpv(evr, 0)));
#line 2496 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_fullname); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_fullname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 1848 "URPM.xs"
  I32 gimme = GIMME_V;
#line 2519 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::fullname",
			"pkg", "URPM::Package");
#line 1850 "URPM.xs"
  if (gimme == G_ARRAY) {
    char *name, *version, *release, *disttag, *distepoch, *arch, *eos;
    int items = 6;

    if(get_fullname_parts(pkg, &name, NULL, &version, &release, &disttag, &distepoch, &arch, &eos))
      croak("invalid fullname");

    EXTEND(SP, items);
    PUSHs(sv_2mortal(newSVpv(name, 0)));
    PUSHs(sv_2mortal(newSVpv(version, 0)));
    PUSHs(sv_2mortal(newSVpv(release, 0)));
    PUSHs(sv_2mortal(newSVpv(disttag, 0)));
    PUSHs(sv_2mortal(newSVpv(distepoch, 0)));
    PUSHs(sv_2mortal(newSVpv(arch, 0)));
    restore_chars();
  } else if (gimme == G_SCALAR) {
    if (pkg->info) {
      char *eos;
      if ((eos = strchr(pkg->info, '@')) != NULL)
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eos-pkg->info)));
    } else if (pkg->h) {
      const char *nvra = get_nvra(pkg->h);
      XPUSHs(sv_2mortal(newSVpvf("%s", nvra)));
      _free(nvra);
    }
  }
#line 2556 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_epoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_epoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
#line 1881 "URPM.xs"
  int epoch;
#line 2577 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::epoch",
			"pkg", "URPM::Package");
#line 1883 "URPM.xs"
  get_fullname_parts(pkg, NULL, &epoch, NULL, NULL, NULL, NULL, NULL, NULL);
  RETVAL = epoch;
#line 2592 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare_pkg); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare_pkg)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "lpkg, rpkg");
    {
	URPM__Package	lpkg;
	URPM__Package	rpkg;
#line 1893 "URPM.xs"
  int compare = 0;
  char *levr;
  char *larch;
  char *revr;
  char *rarch;
#line 2618 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    lpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"lpkg", "URPM::Package");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"rpkg", "URPM::Package");
#line 1899 "URPM.xs"
  if (lpkg == rpkg) RETVAL = 0;
  else {
    levr = (char*)get_evr(lpkg);
    revr = (char*)get_evr(rpkg);
    if(levr == NULL || revr == NULL) {
      restore_chars();
      croak("undefined package");
    }
    compare = do_rpmEVRcompare(levr, revr);
    if (!compare) {
      int lscore, rscore;
      char *platform = NULL;
      if(get_fullname_parts(lpkg, NULL, NULL, NULL, NULL, NULL, NULL, &larch, NULL) ||
	  get_fullname_parts(rpkg, NULL, NULL, NULL, NULL, NULL, NULL, &rarch, NULL))
	croak("undefined package");

      read_config_files(0);

      platform = rpmExpand(larch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
      lscore = rpmPlatformScore(platform, NULL, 0);
      platform = _free(platform);

      platform = rpmExpand(rarch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
      rscore = rpmPlatformScore(platform, NULL, 0);
      platform = _free(platform);

      if (lscore == 0) {
	if (rscore == 0)
#if 0
	  /* Nanar: TODO check this 
	   * hu ?? what is the goal of strcmp, some of arch are equivalent */
	  compare = 0
#endif
	    compare = strcmp(larch, rarch);
	else
	  compare = -1;
      } else {
	if (rscore == 0)
	  compare = 1;
	else
	  compare = rscore - lscore; /* score are lower for better */
      }
    }
    restore_chars();
    RETVAL = compare;
  }
#line 2686 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, evr");
    {
	URPM__Package	pkg;
	char *	evr = (char *)SvPV_nolen(ST(1));
#line 1953 "URPM.xs"
  int compare = 0;
  EVR_t lEVR = rpmEVRnew(RPMSENSE_EQUAL, 0),
        rEVR = rpmEVRnew(RPMSENSE_EQUAL, 0);
#line 2710 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare",
			"pkg", "URPM::Package");
#line 1957 "URPM.xs"
  if (!compare) {
    int i;

    /* This will remove fields from _evr (from the right) that evr is missing
     * so that ie. if only version is given as an argument, it won't compare
     * release etc.
     */
    rpmEVRparse(get_evr(pkg), lEVR);
    rpmEVRparse(evr, rEVR);
    for(i = RPMEVR_V; i <= RPMEVR_D; i++)
      if(!*(rEVR->F[i]))
	lEVR->F[i] = "";

    compare = rpmEVRcompare(lEVR, rEVR);
    rpmEVRfree(lEVR);
    rpmEVRfree(rEVR);
  }
  RETVAL = compare;
#line 2741 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::size",
			"pkg", "URPM::Package");
#line 1982 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      RETVAL = atoi(s+1);
    } else {
      RETVAL = 0;
    }
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_SIZE);
  } else RETVAL = 0;
#line 2783 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_filesize); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filesize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filesize",
			"pkg", "URPM::Package");
#line 2000 "URPM.xs"
  if (pkg->filesize) {
    RETVAL = pkg->filesize;
  } else if (pkg->h) {
    RETVAL = sigsize_to_filesize(get_int(pkg->h, RPMTAG_SIGSIZE));
  } else RETVAL = 0;
#line 2819 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_group)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::group",
			"pkg", "URPM::Package");
#line 2012 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      char *eos = strchr(s+1, '@');
      XPUSHs(sv_2mortal(newSVpv_utf8(s+1, eos != NULL ? eos-s-1 : 0)));
    }
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_GROUP), 0)));
  }
#line 2860 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filename",
			"pkg", "URPM::Package");
#line 2027 "URPM.xs"
  if (pkg->info) {
    char *eon;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
	char savbuf[4];
	memcpy(savbuf, eon, 4); /* there should be at least epoch and size described so (@0@0 minimum) */
	memcpy(eon, ".rpm", 4);
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info+4)));
	memcpy(eon, savbuf, 4);
    }
  } else if (pkg->h) {
    const char *nvra = get_nvra(pkg->h);
    XPUSHs(sv_2mortal(newSVpvf("%s.rpm", nvra)));
    _free(nvra);
  }
#line 2906 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_header_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_header_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::header_filename",
			"pkg", "URPM::Package");
#line 2048 "URPM.xs"
  if (pkg->info) {
    char *eon;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info)));
    }
  } else if (pkg->h) {
    char buff[1024];
    char *p = buff;
    const char *nvra = get_nvra(pkg->h);
    p += snprintf(buff, sizeof(buff), "%s", nvra);
    _free(nvra);
    XPUSHs(sv_2mortal(newSVpv(buff, p-buff)));
  }
#line 2951 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::id",
			"pkg", "URPM::Package");
#line 2067 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
#line 2985 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, id=-1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	id;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_id",
			"pkg", "URPM::Package");

	if (items < 2)
	    id = -1;
	else {
	    id = (int)SvIV(ST(1));
	}
#line 2076 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
  pkg->flag &= ~FLAG_ID;
  pkg->flag |= id >= 0 && id <= FLAG_ID_MAX ? id : FLAG_ID_INVALID;
#line 3028 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::requires",
			"pkg", "URPM::Package");
#line 2086 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION,
		  callback_list_str_xpush_requires, NULL);
  SPAGAIN;
#line 3063 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::requires_nosense",
			"pkg", "URPM::Package");
#line 2095 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, 0, 
		  callback_list_str_xpush_requires, NULL);
  SPAGAIN;
#line 3098 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_suggests); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_suggests)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::suggests",
			"pkg", "URPM::Package");
#line 2104 "URPM.xs"
  PUTBACK;
  int count = return_list_str(pkg->suggests, pkg->h, RPMTAG_SUGGESTSNAME, 0, 0, callback_list_str_xpush, NULL);
  if (count == 0)
    return_list_str(pkg->suggests, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, 0,
		    callback_list_str_xpush_old_suggests, NULL);
  SPAGAIN;
#line 3135 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes",
			"pkg", "URPM::Package");
#line 2115 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3170 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes_nosense",
			"pkg", "URPM::Package");
#line 2124 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3204 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, s, direction=-1");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	direction;
#line 2134 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 3229 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes_overlap",
			"pkg", "URPM::Package");

	if (items < 3)
	    direction = -1;
	else {
	    direction = (int)SvIV(ST(2));
	}
#line 2138 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 3272 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_conflicts); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conflicts",
			"pkg", "URPM::Package");
#line 2169 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3307 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conflicts_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conflicts_nosense",
			"pkg", "URPM::Package");
#line 2178 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3341 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides",
			"pkg", "URPM::Package");
#line 2186 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3376 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides_nosense",
			"pkg", "URPM::Package");
#line 2195 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3410 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, s, direction=1");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	direction;
#line 2205 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 3435 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides_overlap",
			"pkg", "URPM::Package");

	if (items < 3)
	    direction = 1;
	else {
	    direction = (int)SvIV(ST(2));
	}
#line 2209 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 3478 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_buildarchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildarchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildarchs",
			"pkg", "URPM::Package");
#line 2240 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_BUILDARCHS);
  SPAGAIN;
#line 3512 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_excludearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_excludearchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::excludearchs",
			"pkg", "URPM::Package");
#line 2248 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_EXCLUDEARCH);
  SPAGAIN;
#line 3546 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_exclusivearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_exclusivearchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::exclusivearchs",
			"pkg", "URPM::Package");
#line 2256 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_EXCLUSIVEARCH);
  SPAGAIN;
#line 3580 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_dirnames); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_dirnames)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::dirnames",
			"pkg", "URPM::Package");
#line 2264 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_DIRNAMES);
  SPAGAIN;
#line 3614 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_filelinktos); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filelinktos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filelinktos",
			"pkg", "URPM::Package");
#line 2272 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILELINKTOS);
  SPAGAIN;
#line 3648 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files",
			"pkg", "URPM::Package");
#line 2280 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, 0);
  SPAGAIN;
#line 3682 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_digest",
			"pkg", "URPM::Package");
#line 2288 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEDIGESTS);
  SPAGAIN;
#line 3716 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_md5sum); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_md5sum)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2295 "URPM.xs"
  croak("files_md5sum() is dead. use files_digest() instead");
#line 3738 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_owner); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_owner)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_owner",
			"pkg", "URPM::Package");
#line 2301 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEUSERNAME);
  SPAGAIN;
#line 3772 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_group)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_group",
			"pkg", "URPM::Package");
#line 2309 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEGROUPNAME);
  SPAGAIN;
#line 3806 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_mtime",
			"pkg", "URPM::Package");
#line 2317 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEMTIMES);
  SPAGAIN;
#line 3840 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_size",
			"pkg", "URPM::Package");
#line 2325 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILESIZES);
  SPAGAIN;
#line 3874 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_uid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_uid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_uid",
			"pkg", "URPM::Package");
#line 2333 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEUIDS);
  SPAGAIN;
#line 3908 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_gid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_gid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_gid",
			"pkg", "URPM::Package");
#line 2341 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEGIDS);
  SPAGAIN;
#line 3942 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_mode",
			"pkg", "URPM::Package");
#line 2349 "URPM.xs"
  PUTBACK;
  return_list_uint_16(pkg->h, RPMTAG_FILEMODES);
  SPAGAIN;
#line 3976 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_flags",
			"pkg", "URPM::Package");
#line 2357 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEFLAGS);
  SPAGAIN;
#line 4010 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conf_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conf_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conf_files",
			"pkg", "URPM::Package");
#line 2365 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, FILTER_MODE_CONF_FILES);
  SPAGAIN;
#line 4044 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_time",
			"pkg", "URPM::Package");
#line 2373 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_CHANGELOGTIME);
  SPAGAIN;
#line 4078 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_name",
			"pkg", "URPM::Package");
#line 2381 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_CHANGELOGNAME);
  SPAGAIN;
#line 4112 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_text)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_text",
			"pkg", "URPM::Package");
#line 2389 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_CHANGELOGTEXT);
  SPAGAIN;
#line 4146 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_queryformat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_queryformat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fmt");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	char *	fmt = (char *)SvPV_nolen(ST(1));
#line 2398 "URPM.xs"
  char *s;
#line 4170 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::queryformat",
			"pkg", "URPM::Package");
#line 2400 "URPM.xs"
  if (pkg->h) {
    s = headerSprintf(pkg->h, fmt, NULL, NULL, NULL);
      if (s) {
        XPUSHs(sv_2mortal(newSVpv_utf8(s,0)));
      }
  }
#line 4187 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, tagname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	char *	tagname = (char *)SvPV_nolen(ST(1));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::get_tag",
			"pkg", "URPM::Package");
#line 2412 "URPM.xs"
  PUTBACK;
  return_list_tag(pkg, tagname);
  SPAGAIN;
#line 4222 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag_modifiers); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag_modifiers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, tagname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	char *	tagname = (char *)SvPV_nolen(ST(1));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::get_tag_modifiers",
			"pkg", "URPM::Package");
#line 2421 "URPM.xs"
  PUTBACK;
  return_list_tag_modifier(pkg->h, tagname);
  SPAGAIN;
#line 4257 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_pack_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_pack_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::pack_header",
			"pkg", "URPM::Package");
#line 2429 "URPM.xs"
  pack_header(pkg);
#line 4287 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_update_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_update_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "pkg, filename, ...");
    {
	URPM__Package	pkg;
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 2436 "URPM.xs"
  int packing = 0;
  int keep_all_tags = 0;
#line 4309 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::update_header",
			"pkg", "URPM::Package");
#line 2439 "URPM.xs"
  /* compability mode with older interface of parse_hdlist */
  if (items == 3) {
    packing = SvIV(ST(2));
  } else if (items > 3) {
    int i;
    for (i = 2; i < items-1; i+=2) {
      STRLEN len;
      char *s = SvPV(ST(i), len);

      if (len == 7 && !memcmp(s, "packing", 7)) {
	packing = SvTRUE(ST(i + 1));
      } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	keep_all_tags = SvTRUE(ST(i+1));
      }
    }
  }
  RETVAL = update_header(filename, pkg, !packing && keep_all_tags, RPMVSF_DEFAULT);
  if (RETVAL && packing) pack_header(pkg);
#line 4340 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_free_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_free_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::free_header",
			"pkg", "URPM::Package");
#line 2464 "URPM.xs"
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
  pkg->h = NULL;
#line 4371 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, fileno, provides_files=NULL");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));
	char *	provides_files;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::build_info",
			"pkg", "URPM::Package");

	if (items < 3)
	    provides_files = NULL;
	else {
	    provides_files = (char *)SvPV_nolen(ST(2));
	}
#line 2473 "URPM.xs"
  if (pkg->info) {
    char buff[65536];
    size_t size;

    /* info line should be the last to be written */
    if (pkg->provides && *pkg->provides) {
      size = snprintf(buff, sizeof(buff), "@provides@%s\n", pkg->provides);
      if (size < sizeof(buff)) {
	if (provides_files && *provides_files) {
	  --size;
	  size += snprintf(buff+size, sizeof(buff)-size, "@%s\n", provides_files);
	}
	write_nocheck(fileno, buff, size);
      }
    }
    if (pkg->conflicts && *pkg->conflicts) {
      size = snprintf(buff, sizeof(buff), "@conflicts@%s\n", pkg->conflicts);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->obsoletes && *pkg->obsoletes) {
      size = snprintf(buff, sizeof(buff), "@obsoletes@%s\n", pkg->obsoletes);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->requires && *pkg->requires) {
      size = snprintf(buff, sizeof(buff), "@requires@%s\n", pkg->requires);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->suggests && *pkg->suggests) {
      size = snprintf(buff, sizeof(buff), "@suggests@%s\n", pkg->suggests);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->summary && *pkg->summary) {
      size = snprintf(buff, sizeof(buff), "@summary@%s\n", pkg->summary);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->filesize) {
      size = snprintf(buff, sizeof(buff), "@filesize@%d\n", pkg->filesize);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    size = snprintf(buff, sizeof(buff), "@info@%s\n", pkg->info);
    write_nocheck(fileno, buff, size);
  } else croak("no info available for package %s",
	  pkg->h ? get_name(pkg->h, RPMTAG_NAME) : "-");
#line 4450 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fileno");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::build_header",
			"pkg", "URPM::Package");
#line 2522 "URPM.xs"
  if (pkg->h) {
    FD_t fd;

    if ((fd = fdDup(fileno)) != NULL) {
      const char item[] = "Header";
      const char * msg = NULL;
      rpmRC rc = rpmpkgWrite(item, fd, pkg->h, &msg);
      if (rc != RPMRC_OK) {
	rpmlog(RPMLOG_ERR, "%s: %s: %s\n", "rpmkpgWrite", item, msg);
	rc = RPMRC_FAIL;
      }
      msg = (const char*)_free(msg);
      Fclose(fd);
    } else croak("unable to get rpmio handle on fileno %d", fileno);
  } else croak("no header available for package");
#line 4494 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, name");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 2543 "URPM.xs"
  unsigned mask;
#line 4515 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag",
			"pkg", "URPM::Package");
#line 2545 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
#line 4536 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, name, value=1");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
	int	value;
#line 2562 "URPM.xs"
  unsigned mask;
#line 4559 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag",
			"pkg", "URPM::Package");

	if (items < 3)
	    value = 1;
	else {
	    value = (int)SvIV(ST(2));
	}
#line 2564 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
  if (value) pkg->flag |= mask;
  else       pkg->flag &= ~mask;
#line 4588 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_skip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_skip",
			"pkg", "URPM::Package");
#line 2581 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
#line 4620 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_skip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_skip",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2590 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
  if (value) pkg->flag |= FLAG_SKIP;
  else       pkg->flag &= ~FLAG_SKIP;
#line 4661 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_base)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_base",
			"pkg", "URPM::Package");
#line 2600 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
#line 4693 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_base)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_base",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2609 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
  if (value) pkg->flag |= FLAG_BASE;
  else       pkg->flag &= ~FLAG_BASE;
#line 4734 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_disable_obsolete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_disable_obsolete",
			"pkg", "URPM::Package");
#line 2619 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
#line 4766 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_disable_obsolete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_disable_obsolete",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2628 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
  if (value) pkg->flag |= FLAG_DISABLE_OBSOLETE;
  else       pkg->flag &= ~FLAG_DISABLE_OBSOLETE;
#line 4807 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_installed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_installed",
			"pkg", "URPM::Package");
#line 2638 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
#line 4839 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_installed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_installed",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2647 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
  if (value) pkg->flag |= FLAG_INSTALLED;
  else       pkg->flag &= ~FLAG_INSTALLED;
#line 4880 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_requested)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_requested",
			"pkg", "URPM::Package");
#line 2657 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
#line 4912 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_requested)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_requested",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2666 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
  if (value) pkg->flag |= FLAG_REQUESTED;
  else       pkg->flag &= ~FLAG_REQUESTED;
#line 4953 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_required)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_required",
			"pkg", "URPM::Package");
#line 2676 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
#line 4985 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_required)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_required",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2685 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
  if (value) pkg->flag |= FLAG_REQUIRED;
  else       pkg->flag &= ~FLAG_REQUIRED;
#line 5026 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_upgrade)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_upgrade",
			"pkg", "URPM::Package");
#line 2695 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
#line 5058 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_upgrade)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_upgrade",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2704 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
  if (value) pkg->flag |= FLAG_UPGRADE;
  else       pkg->flag &= ~FLAG_UPGRADE;
#line 5099 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_selected); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_selected)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_selected",
			"pkg", "URPM::Package");
#line 2714 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0;
#line 5131 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_available); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_available)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_available",
			"pkg", "URPM::Package");
#line 2722 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_INSTALLED && !(pkg->flag & FLAG_UPGRADE)) ||
           (pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0);
#line 5164 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::rate",
			"pkg", "URPM::Package");
#line 2731 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
#line 5196 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, rate");
    {
	URPM__Package	pkg;
	int	rate = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_rate",
			"pkg", "URPM::Package");
#line 2740 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
  pkg->flag &= ~FLAG_RATE;
  pkg->flag |= (rate >= 0 && rate <= FLAG_RATE_MAX ? rate : FLAG_RATE_INVALID) << FLAG_RATE_POS;
#line 5231 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rflags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 2750 "URPM.xs"
  I32 gimme = GIMME_V;
#line 5254 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::rflags",
			"pkg", "URPM::Package");
#line 2752 "URPM.xs"
  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }
#line 5274 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rflags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "pkg, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 2766 "URPM.xs"
  I32 gimme = GIMME_V;
  char *new_rflags;
  STRLEN total_len;
  int i;
#line 5300 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_rflags",
			"pkg", "URPM::Package");
#line 2771 "URPM.xs"
  total_len = 0;
  for (i = 1; i < items; ++i)
    total_len += SvCUR(ST(i)) + 1;

  new_rflags = malloc(total_len);
  total_len = 0;
  for (i = 1; i < items; ++i) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    memcpy(new_rflags + total_len, s, len);
    new_rflags[total_len + len] = '\t';
    total_len += len + 1;
  }
  new_rflags[total_len - 1] = 0; /* but mark end-of-string correctly */

  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }

  free(pkg->rflags);
  pkg->rflags = new_rflags;
#line 5338 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__DB_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "prefix=NULL, write_perm=0");
    {
	char *	prefix;
	int	write_perm;
#line 2807 "URPM.xs"
  URPM__DB db;
#line 5360 "URPM.c"
	URPM__DB	RETVAL;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}

	if (items < 2)
	    write_perm = 0;
	else {
	    write_perm = (int)SvIV(ST(1));
	}
#line 2809 "URPM.xs"
  read_config_files(0);
  db = malloc(sizeof(struct s_Transaction));
  db->count = 1;
  db->ts = rpmtsCreate();
  if(prefix && prefix[0] && prefix[0] != '/') {
    char relpath[PATH_MAX];
    size_t len;

    if(getcwd(relpath, sizeof(relpath)) == NULL)
      croak("%s", strerror(errno));
    len = strlen(relpath);
    snprintf(&(relpath[len]), sizeof(relpath)-len, "/%s", prefix);
    rpmtsSetRootDir(db->ts, relpath);
  } else {
    rpmtsSetRootDir(db->ts, prefix && prefix[0] ? prefix : NULL);
  }
  if (rpmtsOpenDB(db->ts, write_perm ? O_RDWR | O_CREAT : O_RDONLY) == 0) {
    RETVAL = db;
  } else {
    RETVAL = NULL;
    (void)rpmtsFree(db->ts);
    free(db);
  }
#line 5398 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::DB", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_rebuild); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_rebuild)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=NULL");
    {
	char *	prefix;
#line 2839 "URPM.xs"
  rpmts ts;
#line 5420 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}
#line 2841 "URPM.xs"
  read_config_files(0);
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsRebuildDB(ts) == 0;
  (void)rpmtsFree(ts);
#line 5435 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=NULL");
    {
	char *	prefix;
#line 2853 "URPM.xs"
  rpmts ts;
#line 5456 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}
#line 2855 "URPM.xs"
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsVerifyDB(ts) == 0;
  ts = rpmtsFree(ts);
#line 5470 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	URPM__DB	db;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::DB::DESTROY",
			"db");
#line 2866 "URPM.xs"
  (void)rpmtsFree(db->ts);
  if (!--db->count) free(db);
#line 5501 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__DB_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "db, callback");
    {
	URPM__DB	db;
	SV *	callback = ST(1);
#line 2874 "URPM.xs"
  Header header;
  rpmmi mi;
  int count = 0;
#line 5524 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse",
			"db", "URPM::DB");
#line 2878 "URPM.xs"
  db->ts = rpmtsLink(db->ts, "URPM::DB::traverse");
  ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((header = rpmmiNext(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));

      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = header;

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;

      call_sv(callback, G_DISCARD | G_SCALAR);

      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++count;
  }
  mi = rpmmiFree(mi);
  (void)rpmtsFree(db->ts);
  RETVAL = count;
#line 5562 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_traverse_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, names, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1));
	SV *	names = ST(2);
	SV *	callback = ST(3);
#line 2913 "URPM.xs"
  Header header;
  rpmmi mi;
  int count = 0;
#line 5588 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse_tag",
			"db", "URPM::DB");
#line 2917 "URPM.xs"
  if (SvROK(names) && SvTYPE(SvRV(names)) == SVt_PVAV) {
    AV* names_av = (AV*)SvRV(names);
    int len = av_len(names_av);
    int i;
    rpmTag rpmtag;

    rpmtag = rpmtag_from_string(tag);

    for (i = 0; i <= len; ++i) {
      STRLEN str_len;
      SV **isv = av_fetch(names_av, i, 0);
      char *name = SvPV(*isv, str_len);
      db->ts = rpmtsLink(db->ts, "URPM::DB::traverse_tag");
      ts_nosignature(db->ts);
      mi = rpmtsInitIterator(db->ts, rpmtag, name, str_len);
      while ((header = rpmmiNext(mi))) {
	if (SvROK(callback)) {
	  dSP;
	  URPM__Package pkg = calloc(1, sizeof(struct s_Package));

	  pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
	  pkg->h = header;

	  PUSHMARK(SP);
	  XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
	  PUTBACK;

	  call_sv(callback, G_DISCARD | G_SCALAR);

	  SPAGAIN;
	  pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
	}
	++count;
      }
      (void)rpmmiFree(mi);
      (void)rpmtsFree(db->ts);
    } 
  } else croak("bad arguments list");
  RETVAL = count;
#line 5640 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_traverse_tag_find); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse_tag_find)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, name, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1));
	char *	name = (char *)SvPV_nolen(ST(2));
	SV *	callback = ST(3);
#line 2966 "URPM.xs"
  Header header;
  rpmmi mi;
#line 5665 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse_tag_find",
			"db", "URPM::DB");
#line 2969 "URPM.xs"
  rpmTag rpmtag = rpmtag_from_string(tag);
  int found = 0;

  db->ts = rpmtsLink(db->ts, "URPM::DB::traverse_tag");
  ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, rpmtag, name, 0);
  while ((header = rpmmiNext(mi))) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));

      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = header;

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;

      int count = call_sv(callback, G_SCALAR);

      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */

      if (count == 1 && POPi) {
	found = 1;
	break;
      }
  }
  (void)rpmmiFree(mi);
  (void)rpmtsFree(db->ts);
  RETVAL = found;
#line 5708 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_create_transaction); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_create_transaction)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, prefix=NULL");
    {
	URPM__DB	db;
	char *	prefix;
	URPM__Transaction	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::create_transaction",
			"db", "URPM::DB");

	if (items < 2)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(1));
	}
#line 3007 "URPM.xs"
  /* this is *REALLY* dangerous to create a new transaction while another is open,
     so use the db transaction instead. */
  db->ts = rpmtsLink(db->ts, "URPM::DB::create_transaction");
  ++db->count;
  RETVAL = db;
#line 5750 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::Transaction", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::Transaction::DESTROY",
			"trans");
#line 3022 "URPM.xs"
  (void)rpmtsFree(trans->ts);
  if (!--trans->count) free(trans);
#line 5782 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_set_script_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_set_script_fd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, fdno");
    {
	URPM__Transaction	trans;
	int	fdno = (int)SvIV(ST(1));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::set_script_fd",
			"trans", "URPM::Transaction");
#line 3030 "URPM.xs"
  rpmtsSetScriptFd(trans->ts, fdDup(fdno));
#line 5812 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "trans, pkg, ...");
    {
	URPM__Transaction	trans;
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::add",
			"trans", "URPM::Transaction");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::add",
			"pkg", "URPM::Package");
#line 3037 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX && pkg->h != NULL) {
    int update = 0;
    int rc;
    rpmRelocation  relocations = NULL;
    /* compability mode with older interface of add */
    if (items == 3) {
      update = SvIV(ST(2));
    } else if (items > 3) {
      int i;
      for (i = 2; i < items-1; i+=2) {
	STRLEN len;
	char *s = SvPV(ST(i), len);

	if (len == 6 && !memcmp(s, "update", 6)) {
	  update = SvIV(ST(i+1));
	} else if (len == 11 && !memcmp(s, "excludepath", 11)) {
	  if (SvROK(ST(i+1)) && SvTYPE(SvRV(ST(i+1))) == SVt_PVAV) {
	    AV *excludepath = (AV*)SvRV(ST(i+1));
	    I32 j = 1 + av_len(excludepath);
	    int relno = 0;
	    relocations = malloc(sizeof(rpmRelocation));
	    while (--j >= 0) {
	      SV **e = av_fetch(excludepath, j, 0);
	      if (e != NULL && *e != NULL) {
		rpmfiAddRelocation(&relocations, &relno, SvPV_nolen(*e), NULL);
	      }
	    }
	  }
	}
      }
    }
    rc = rpmtsAddInstallElement(trans->ts, pkg->h, (fnpyKey)(1+(long)(pkg->flag & FLAG_ID)), update, relocations);
    if(rc) {
      rpmps ps = rpmtsProblems(trans->ts);
      PUTBACK;
      return_problems(ps, 1, 0);
      SPAGAIN;
    }

    /* free allocated memory, check rpm is copying it just above, at least in 4.0.4 */
    rpmfiFreeRelocations(relocations);
    RETVAL = rc == 0;
  } else RETVAL = 0;
#line 5895 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, name");
    {
	URPM__Transaction	trans;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 3088 "URPM.xs"
  Header h;
  rpmmi mi;
  int count = 0;
  char *boa = NULL, *bor = NULL;
#line 5920 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::remove",
			"trans", "URPM::Transaction");
#line 3093 "URPM.xs"
  /* hide arch in name if present */
  if ((boa = strrchr(name, '.'))) {
    *boa = 0;
    if ((bor = strrchr(name, '-'))) {
      *bor = 0;
      if (!strrchr(name, '-')) {
	*boa = '.'; boa = NULL;
      }
      *bor = '-'; bor = NULL;
    } else {
      *boa = '.'; boa = NULL;
    }
  }
  mi = rpmtsInitIterator(trans->ts, RPMTAG_NVRA, name, 0);
  while ((h = rpmmiNext(mi))) {
    unsigned int recOffset = rpmmiInstance(mi);
    if (recOffset != 0) {
      rpmtsAddEraseElement(trans->ts, h, recOffset);
      ++count;
    }
  }
  mi = rpmmiFree(mi);
  if (boa) *boa = '.';
  RETVAL=count;
#line 5957 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_traverse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, callback");
    {
	URPM__Transaction	trans;
	SV *	callback = ST(1);
#line 3125 "URPM.xs"
  rpmmi mi;
  Header h;
  int c = 0;
#line 5981 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::traverse",
			"trans", "URPM::Transaction");
#line 3129 "URPM.xs"
  mi = rpmtsInitIterator(trans->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((h = rpmmiNext(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));
      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = h;
      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;
      call_sv(callback, G_DISCARD | G_SCALAR);
      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++c;
  }
  mi = rpmmiFree(mi);
  RETVAL = c;
#line 6012 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "trans, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 3154 "URPM.xs"
  I32 gimme = GIMME_V;
  int translate_message = 0;
  int i, r;
#line 6037 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::check",
			"trans", "URPM::Transaction");
#line 3158 "URPM.xs"
  for (i = 1; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 17 && !memcmp(s, "translate_message", 17)) {
      translate_message = SvIV(ST(i+1));
    }
  }
  r = rpmtsCheck(trans->ts);
  rpmps ps = rpmtsProblems(trans->ts);
  if (rpmpsNumProblems(ps) > 0) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      /* now translation is handled by rpmlib, but only for version 4.2 and above */
      PUTBACK;
      return_problems(ps, 1, 0);
      SPAGAIN;
    }
  } else if (gimme == G_SCALAR) {
    XPUSHs(sv_2mortal(newSViv(1)));
  }
  if(r == 1)
    XPUSHs(sv_2mortal(newSVpv("error while checking dependencies", 0)));

  ps = rpmpsFree(ps);
#line 6074 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_order); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_order)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 3189 "URPM.xs"
  I32 gimme = GIMME_V;
#line 6097 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::order",
			"trans", "URPM::Transaction");
#line 3191 "URPM.xs"
  if (rpmtsOrder(trans->ts) == 0) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(1)));
    }
  } else {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVpv("error while ordering dependencies", 0)));
    }
  }
#line 6119 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_NElements); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_NElements)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::NElements",
			"trans", "URPM::Transaction");
#line 3207 "URPM.xs"
  RETVAL = rpmtsNElements(trans->ts);
#line 6151 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_name",
			"trans", "URPM::Transaction");
#line 3216 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteN(te) : NULL;
#line 6185 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_epoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_epoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_epoch",
			"trans", "URPM::Transaction");
#line 3226 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteE(te) : NULL;
#line 6219 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_version",
			"trans", "URPM::Transaction");
#line 3236 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteV(te) : NULL;
#line 6253 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_release); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_release)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_release",
			"trans", "URPM::Transaction");
#line 3246 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteR(te) : NULL;
#line 6287 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_distepoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_distepoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_distepoch",
			"trans", "URPM::Transaction");
#line 3256 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteD(te) : NULL;
#line 6321 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_fullname); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_fullname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_fullname",
			"trans", "URPM::Transaction");
#line 3267 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteNEVRA(te) : NULL;
#line 6355 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_run); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_run)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "trans, data, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
	SV *	data = ST(1);
#line 3277 "URPM.xs"
  struct s_TransactionData td = { NULL, NULL, NULL, NULL, NULL, 100000, data };
  rpmtransFlags transFlags = RPMTRANS_FLAG_NONE;
  int probFilter = 0;
  int translate_message = 0, raw_message = 0;
  int i;
#line 6383 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::run",
			"trans", "URPM::Transaction");
#line 3283 "URPM.xs"
  for (i = 2 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 4 && !memcmp(s, "test", 4)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_TEST;
    } else if (len == 11 && !memcmp(s, "excludedocs", 11)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_NODOCS;
    } else if (len == 5) {
      if (!memcmp(s, "force", 5)) {
	if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_REPLACEPKG |
					  RPMPROB_FILTER_REPLACEOLDFILES |
					  RPMPROB_FILTER_REPLACENEWFILES |
					  RPMPROB_FILTER_OLDPACKAGE);
      } else if (!memcmp(s, "delta", 5))
	td.min_delta = SvIV(ST(i+1));
    } else if (len == 6 && !memcmp(s, "nosize", 6)) {
      if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_DISKSPACE|RPMPROB_FILTER_DISKNODES);
    } else if (len == 9 && !memcmp(s, "noscripts", 9)) {
      if (SvIV(ST(i+1))) transFlags |= (RPMTRANS_FLAG_NOSCRIPTS |
				        RPMTRANS_FLAG_NOPRE |
				        RPMTRANS_FLAG_NOPREUN |
				        RPMTRANS_FLAG_NOPOST |
				        RPMTRANS_FLAG_NOPOSTUN );
    } else if (len == 10 && !memcmp(s, "oldpackage", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_OLDPACKAGE;
    } else if (len == 11 && !memcmp(s, "replacepkgs", 11)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEPKG;
    } else if (len == 11 && !memcmp(s, "raw_message", 11)) {
      raw_message = 1;
    } else if (len == 12 && !memcmp(s, "replacefiles", 12)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEOLDFILES | RPMPROB_FILTER_REPLACENEWFILES;
    } else if (len == 9 && !memcmp(s, "repackage", 9)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_REPACKAGE;
    } else if (len == 6 && !memcmp(s, "justdb", 6)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_JUSTDB;
    } else if (len == 10 && !memcmp(s, "ignorearch", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_IGNOREARCH;
    } else if (len == 17 && !memcmp(s, "translate_message", 17))
      translate_message = 1;
    else if (len >= 9 && !memcmp(s, "callback_", 9)) {
      if (len == 9+4 && !memcmp(s+9, "open", 4)) {
	if (SvROK(ST(i+1))) td.callback_open = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "close", 5)) {
	if (SvROK(ST(i+1))) td.callback_close = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "trans", 5)) {
	if (SvROK(ST(i+1))) td.callback_trans = ST(i+1);
      } else if (len == 9+6 && !memcmp(s+9, "uninst", 6)) {
	if (SvROK(ST(i+1))) td.callback_uninst = ST(i+1);
      } else if (len == 9+4 && !memcmp(s+9, "inst", 4)) {
	if (SvROK(ST(i+1))) td.callback_inst = ST(i+1);
      }
    }
  }
  /* check macros */
  {
    char *repa = rpmExpand("%_repackage_all_erasures", NULL);
    if (repa && *repa && *repa != '0')
      transFlags |= RPMTRANS_FLAG_REPACKAGE;
    if (repa) free(repa);
  }
  rpmtsSetFlags(trans->ts, transFlags);
  trans->ts = rpmtsLink(trans->ts, "URPM::Transaction::run");
  rpmtsSetNotifyCallback(trans->ts, rpmRunTransactions_callback, &td);
  if (rpmtsRun(trans->ts, NULL, probFilter) > 0) {
    rpmps ps = rpmtsProblems(trans->ts);
    PUTBACK;
    return_problems(ps, translate_message, raw_message || !translate_message);
    SPAGAIN;
    ps = rpmpsFree(ps);
  }
  rpmtsEmpty(trans->ts);
  (void)rpmtsFree(trans->ts);
#line 6467 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_bind_rpm_textdomain_codeset); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_bind_rpm_textdomain_codeset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 3365 "URPM.xs"
  rpm_codeset_is_utf8 = 1;
  bind_textdomain_codeset("rpm", "UTF-8");
#line 6488 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_read_config_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_read_config_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 3371 "URPM.xs"
  RETVAL = (read_config_files(1) == 0); /* force re-read of configuration files */
#line 6509 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_list_rpm_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_list_rpm_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "urpm=Nullsv");
    {
	SV *	urpm;

	if (items < 1)
	    urpm = Nullsv;
	else {
	    urpm = ST(0);
	}
#line 3379 "URPM.xs"
   croak("list_rpm_tag() has been removed from perl-URPM. please report if you need it back");
#line 6536 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmvercmp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char *	one = (char *)SvPV_nolen(ST(0));
	char *	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_rpmEVRcmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmEVRcmp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char *	one = (char *)SvPV_nolen(ST(0));
	char *	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmEVRcmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_rpmEVRcompare); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmEVRcompare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char *	one = (char *)SvPV_nolen(ST(0));
	char *	two = (char *)SvPV_nolen(ST(1));
#line 3396 "URPM.xs"
  int compare;
#line 6603 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3398 "URPM.xs"
  compare = do_rpmEVRcompare(one, two);
  RETVAL = compare;
#line 6609 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_ranges_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_ranges_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	char *	a = (char *)SvPV_nolen(ST(0));
	char *	b = (char *)SvPV_nolen(ST(1));
#line 3409 "URPM.xs"
  char *sa = a, *sb = b;
  int aflags = 0, bflags = 0;
#line 6632 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3412 "URPM.xs"
  while (*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=' && *sa == *sb) {
    ++sa;
    ++sb;
  }
  if ((*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=') ||
      (*sb && *sb != ' ' && *sb != '[' && *sb != '<' && *sb != '>' && *sb != '=')) {
    /* the strings are sure to be different */
    RETVAL = 0;
  } else {
    while (*sa) {
      if (*sa == ' ' || *sa == '[' || *sa == '*' || *sa == ']');
      else if (*sa == '<') aflags |= RPMSENSE_LESS;
      else if (*sa == '>') aflags |= RPMSENSE_GREATER;
      else if (*sa == '=') aflags |= RPMSENSE_EQUAL;
      else break;
      ++sa;
    }
    while (*sb) {
      if (*sb == ' ' || *sb == '[' || *sb == '*' || *sb == ']');
      else if (*sb == '<') bflags |= RPMSENSE_LESS;
      else if (*sb == '>') bflags |= RPMSENSE_GREATER;
      else if (*sb == '=') bflags |= RPMSENSE_EQUAL;
      else break;
      ++sb;
    }
    RETVAL = ranges_overlap(aflags, sa, bflags, sb);
  }
#line 6663 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_parse_synthesis__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_synthesis__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3447 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      char buff[65536];
      char *p, *eol;
      int buff_len;
      struct s_Package pkg;
      xFile xF;
      lzma_ret ret = LZMA_STREAM_END;
      int start_id = 1 + av_len(depslist);
      SV *callback = NULL;

      if (items > 2) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  }
	}
      }

      PUTBACK;
      if ((xF = xOpen(filename)).type < XF_FAIL) {
	memset(&pkg, 0, sizeof(struct s_Package));
	buff[sizeof(buff)-1] = 0;
	p = buff;
	int ok = 1;
	while ((buff_len = xRead(&xF, &ret, p, sizeof(buff)-1-(p-buff))) >= 0 &&
	       (buff_len += p-buff)) {
	  buff[buff_len] = 0;
	  p = buff;
	  if ((eol = strchr(p, '\n')) != NULL) {
	    do {
	      *eol++ = 0;
	      if (!parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback)) { ok = 0; break; }
	      p = eol;
	    } while ((eol = strchr(p, '\n')) != NULL);
	  } else {
	    /* a line larger than sizeof(buff) has been encountered, bad file problably */
	    fprintf(stderr, "invalid line <%s>\n%s\n", p, buff);
	    ok = 0;
	    break;
	  }
	  if (xF.eof) {
	    if (!parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback)) ok = 0;
	    break;
	  } else {
	    /* move the remaining non-complete-line at beginning */
	    memmove(buff, p, buff_len-(p-buff));
	    /* point to the end of the non-complete-line */
	    p = &buff[buff_len-(p-buff)];
	  }
	}
	if(ret != LZMA_STREAM_END) ok = 0;
	if (xClose(&xF) != 0) ok = 0;
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!errno) errno = EINVAL; /* zlib error */
	  if (!nofatal || !SvIV(*nofatal))
	      croak(errno == ENOENT
		      ? "unable to read synthesis file %s"
		      : "unable to uncompress synthesis file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 6765 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_hdlist__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_hdlist__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3532 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      pid_t pid = 0;
      int d;
      int empty_archive = 0;
      FD_t fd;

      d = open_archive(filename, &pid, &empty_archive);
      fd = fdDup(d);
      close(d);

      if (empty_archive) {
	XPUSHs(sv_2mortal(newSViv(1 + av_len(depslist))));
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else if (d >= 0 && fd) {
	rpmts ts = NULL;
	rpmgi gi = NULL;
	rpmRC rc = RPMRC_NOTFOUND;
	int start_id = 1 + av_len(depslist);
	int packing = 0;
	SV *callback = NULL;

	/* compability mode with older interface of parse_hdlist */
	if (items == 3) {
	  packing = SvTRUE(ST(2));
	} else if (items > 3) {
	  int i;
	  for (i = 2; i < items-1; i+=2) {
	    STRLEN len;
	    char *s = SvPV(ST(i), len);

	    if (len == 7 && !memcmp(s, "packing", 7)) {
	      packing = SvTRUE(ST(i+1));
	    } else if (len == 8 && !memcmp(s, "callback", 8)) {
	      if (SvROK(ST(i+1))) callback = ST(i+1);
	    }
	  }
	}

	PUTBACK;
	rc = RPMRC_NOTFOUND;
	ts = rpmtsCreate();
	rpmtsSetRootDir(ts, NULL);
	gi = rpmgiNew(ts, RPMDBI_HDLIST, NULL, 0);

	rpmtsSetVSFlags(ts, _RPMVSF_NOSIGNATURES | RPMVSF_NOHDRCHK | _RPMVSF_NOPAYLOAD | _RPMVSF_NOHEADER);
	gi->active = 1;
	gi->fd = fd;
	while ((rc = rpmgiNext(gi)) == RPMRC_OK) {
	  struct s_Package pkg, *_pkg;
	  SV *sv_pkg;

	  memset(&pkg, 0, sizeof(struct s_Package));
	  pkg.flag = 1 + av_len(depslist);
	  pkg.h = rpmgiHeader(gi);
	  /* prevent rpmgiNext() from freeing header */
	  gi->h = NULL;
	  sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
	      _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package)));
	  if (call_package_callback(urpm, sv_pkg, callback)) {
	    if (provides) {
	      update_provides(_pkg, provides);
	      update_provides_files(_pkg, provides);
	    }
	    if (obsoletes) update_obsoletes(_pkg, obsoletes);
	    if (packing) pack_header(_pkg);
	    av_push(depslist, sv_pkg);
	  }
	}
	gi = rpmgiFree(gi);
	ts = rpmtsFree(ts);

	int ok = 1;

	if (pid) {
	  kill(pid, SIGTERM);
	  int status;
	  int rc = waitpid(pid, &status, 0);
	  ok = rc != -1 && WEXITSTATUS(status) != 1; /* in our standard case, gzip will exit with status code 2, meaning "decompression OK, trailing garbage ignored" */
	  pid = 0;
	} else if (!empty_archive) {
	  ok = av_len(depslist) >= start_id;
	}
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	if (!nofatal || !SvIV(*nofatal))
	  croak("cannot open hdlist file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 6890 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_rpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3640 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 8, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      struct s_Package pkg, *_pkg;
      SV *sv_pkg;
      int packing = 0;
      int keep_all_tags = 0;
      SV *callback = NULL;
      rpmVSFlags vsflags = RPMVSF_DEFAULT;

      /* compability mode with older interface of parse_hdlist */
      if (items == 3) {
	packing = SvTRUE(ST(2));
      } else if (items > 3) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 7 && !memcmp(s, "packing", 7)) {
	    packing = SvTRUE(ST(i + 1));
	  } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	    keep_all_tags = SvTRUE(ST(i+1));
	  } else if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  } else if (len == 5) {
            if (!memcmp(s, "nopgp", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nogpg", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nomd5", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOMD5 |  RPMVSF_NOMD5HEADER);
            }
            else if (!memcmp(s, "norsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NORSA | RPMVSF_NORSAHEADER);
            }
            else if (!memcmp(s, "nodsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NODSA | RPMVSF_NODSAHEADER);
            }
          } else if (len == 9) {
            if (!memcmp(s, "nodigests", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NODIGESTS;
            } else
            if (!memcmp(s, "nopayload", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NOPAYLOAD;
            }
          } 
	}
      }
      PUTBACK;
      memset(&pkg, 0, sizeof(struct s_Package));
      pkg.flag = 1 + av_len(depslist);
      _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package));

      if (update_header(filename, _pkg, keep_all_tags, vsflags)) {
	sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package", _pkg);
	if (call_package_callback(urpm, sv_pkg, callback)) {
	  if (provides) {
	    update_provides(_pkg, provides);
	    update_provides_files(_pkg, provides);
	  }
	  if (obsoletes) update_obsoletes(_pkg, obsoletes);
	  if (packing) pack_header(_pkg);
	  av_push(depslist, sv_pkg);
	}
	SPAGAIN;
	/* only one element read */
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else free(_pkg);
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 6993 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_verify_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_rpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "filename, ...");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3725 "URPM.xs"
  FD_t fd;
  int i, oldlogmask;
  rpmts ts = NULL;
  struct rpmQVKArguments_s qva;
#line 7017 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3730 "URPM.xs"
  /* Don't display error messages */
  oldlogmask = rpmlogSetMask(RPMLOG_UPTO(RPMLOG_PRI(4)));
  memset(&qva, 0, sizeof(struct rpmQVKArguments_s));
  qva.qva_source = RPMQV_RPM;
  qva.qva_flags = VERIFY_ALL;
  for (i = 1 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    if (len == 9 && !strncmp(s, "nodigests", 9)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_DIGEST;
    } else if (len == 12 && !strncmp(s, "nosignatures", 12)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_SIGNATURE;
    }
  }
  fd = Fopen(filename, "r");
  if (fd == NULL) {
    RETVAL = 0;
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, NULL);
    rpmtsOpenDB(ts, O_RDONLY);
    if (rpmVerifySignatures(&qva, ts, fd, filename)) {
      RETVAL = 0;
    } else {
      RETVAL = 1;
    }
    Fclose(fd);
    (void)rpmtsFree(ts);
  }
  rpmlogSetMask(oldlogmask);

#line 7053 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_get_gpg_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_get_gpg_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3770 "URPM.xs"
    uint8_t fingerprint[sizeof(pgpKeyID_t)];
    char fingerprint_str[sizeof(pgpKeyID_t) * 2 + 1];
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;

#line 7079 "URPM.c"
	char *	RETVAL;
	dXSTARG;
#line 3777 "URPM.xs"
    memset (fingerprint, 0, sizeof (fingerprint));
    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0) {
	pktlen = 0;
    } else if (rc != PGPARMOR_PUBKEY) {
	pktlen = 0;
    } else {
	unsigned int i;
        pgpPubkeyFingerprint (pkt, pktlen, fingerprint);
   	for (i = 0; i < sizeof (pgpKeyID_t); i++) {
	    sprintf(&fingerprint_str[i*2], "%02x", fingerprint[i]);
	}
    }
    _free(pkt);
    RETVAL = fingerprint_str;
#line 7097 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_verify_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filename, prefix=NULL");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
	char *	prefix;
#line 3800 "URPM.xs"
  rpmts ts = NULL;
  char result[1024];
  rpmRC rc;
  FD_t fd;
  Header h;
#line 7123 "URPM.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(1));
	}
#line 3806 "URPM.xs"
  fd = Fopen(filename, "r");
  if (fd == NULL) {
    RETVAL = "NOT OK (could not read file)";
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, prefix);
    rpmtsOpenDB(ts, O_RDONLY);
    rpmtsSetVSFlags(ts, RPMVSF_DEFAULT);
    rc = rpmReadPackageFile(ts, fd, filename, &h);
    Fclose(fd);
    *result = '\0';
    switch(rc) {
      case RPMRC_OK:
	if (h) {
	  char *fmtsig = headerSprintf(
	      h,
	      "%|DSAHEADER?{%{DSAHEADER:pgpsig}}:{%|RSAHEADER?{%{RSAHEADER:pgpsig}}:"
	      "{%|SIGGPG?{%{SIGGPG:pgpsig}}:{%|SIGPGP?{%{SIGPGP:pgpsig}}:{(none)}|}|}|}|",
	      NULL,
	      NULL,
	      NULL);
	  snprintf(result, sizeof(result), "OK (%s)", fmtsig);
	  free(fmtsig);
	} else snprintf(result, sizeof(result), "NOT OK (bad rpm): %s", rpmlogMessage());
	break;
      case RPMRC_NOTFOUND:
	snprintf(result, sizeof(result), "NOT OK (signature not found): %s", rpmlogMessage());
	break;
      case RPMRC_FAIL:
	snprintf(result, sizeof(result), "NOT OK (fail): %s", rpmlogMessage());
	break;
      case RPMRC_NOTTRUSTED:
	snprintf(result, sizeof(result), "NOT OK (key not trusted): %s", rpmlogMessage());
	break;
      case RPMRC_NOKEY:
	snprintf(result, sizeof(result), "NOT OK (no key): %s", rpmlogMessage());
	break;
    }
    RETVAL = result;
    if (h) h = headerFree(h);
    (void)rpmtsFree(ts);
  }

#line 7177 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_import_pubkey_file); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_import_pubkey_file)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "db, filename");
    {
	URPM__DB	db;
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3859 "URPM.xs"
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;
#line 7201 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::import_pubkey_file",
			"db", "URPM::DB");
#line 3864 "URPM.xs"
    rpmts ts = rpmtsLink(db->ts, "URPM::import_pubkey_file");
    rpmtsClean(ts);

    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0) {
        RETVAL = 0;
    } else if (rc != PGPARMOR_PUBKEY) {
        RETVAL = 0;
    } else if (rpmcliImportPubkey(ts, pkt, pktlen) != RPMRC_OK) {
        RETVAL = 0;
    } else {
        RETVAL = 1;
    }
    pkt = _free(pkt);
    (void)rpmtsFree(ts);
#line 7228 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_import_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_import_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 3884 "URPM.xs"
  unused_variable(&items);
  croak("import_pubkey() is dead. use import_pubkey_file() instead");
  RETVAL = 1;
#line 7251 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_archscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_archscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "arch");
    {
	const char *	arch = (const char *)SvPV_nolen(ST(0));
#line 3894 "URPM.xs"
  char * platform = NULL;
#line 7272 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3896 "URPM.xs"
  read_config_files(0);
  platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
  RETVAL=rpmPlatformScore(platform, NULL, 0);
  _free(platform);
#line 7280 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_osscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_osscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "os");
    {
	const char *	os = (const char *)SvPV_nolen(ST(0));
#line 3907 "URPM.xs"
  char * platform = NULL;
#line 7301 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3909 "URPM.xs"
  read_config_files(0);
  platform = rpmExpand("%{_target_cpu}-%{_target_vendor}-", os, "%{?_gnu}", NULL);
  RETVAL=rpmPlatformScore(platform, NULL, 0);
  _free(platform);
#line 7309 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_platformscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_platformscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "platform");
    {
	const char *	platform = (const char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;
#line 3920 "URPM.xs"
  read_config_files(0);
  RETVAL=rpmPlatformScore(platform, NULL, 0);
#line 7333 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_stream2header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_stream2header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
#line 3929 "URPM.xs"
    FD_t fd;
    URPM__Package pkg;
#line 7357 "URPM.c"
#line 3932 "URPM.xs"
    if ((fd = fdDup(fileno(fp)))) {
	const char item[] = "Header";
	const char * msg = NULL;
	rpmRC rc;

	pkg = (URPM__Package)calloc(1, sizeof(struct s_Package));
	rc = rpmpkgRead(item, fd, &pkg->h, &msg);

	switch (rc) {
	  default:
	    rpmlog(RPMLOG_ERR, "%s: %s: %s\n", "rpmpkgRead", item, msg);
	  case RPMRC_NOTFOUND:
	    pkg->h = NULL;
	  case RPMRC_OK:
	    break;
	}
	msg = (const char*)_free(msg);
        if (pkg->h) {
            SV *sv_pkg;
            EXTEND(SP, 1);
            sv_pkg = sv_newmortal();
            sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
            PUSHs(sv_pkg);
        }
        Fclose(fd);
    }
#line 7385 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_spec2srcheader); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_spec2srcheader)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "specfile");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	specfile = (char *)SvPV_nolen(ST(0));
#line 3963 "URPM.xs"
    rpmts ts = rpmtsCreate();
    URPM__Package pkg;
    Spec spec = NULL;
#line 7410 "URPM.c"
#line 3967 "URPM.xs"
/* ensure the config is in memory with all macro */
  read_config_files(0);
/* Do not verify architecture */
#define SPEC_ANYARCH 1
/* Do not verify whether sources exist */
#define SPEC_FORCE 1
  if (!parseSpec(ts, specfile, "/", 0, NULL, NULL, SPEC_ANYARCH, SPEC_FORCE, 0)) {
    SV *sv_pkg;
    HE_t he;

    spec = rpmtsSetSpec(ts, NULL);
    initSourceHeader(spec, NULL);
    pkg = (URPM__Package)calloc(1, sizeof(struct s_Package));
    he = (HE_t)memset(alloca(sizeof(*he)), 0, sizeof(*he));

    he->tag = RPMTAG_SOURCERPM;
    he->p.str = "";
    he->c = 1;
    headerPut(spec->sourceHeader, he, 0);

    {
      HE_t he = (HE_t)memset(alloca(sizeof(*he)), 0, sizeof(*he));
      he->tag = RPMTAG_ARCH;
      he->t = RPM_STRING_TYPE;
      he->p.str = "src";
      he->c = 1,
      /* parseSpec() sets RPMTAG_ARCH to %{_target_cpu} whereas we really a header similar to .src.rpm header */
      headerMod(spec->sourceHeader, he, 0);
    }

    pkg->h = headerLink(spec->sourceHeader);
    sv_pkg = sv_newmortal();
    sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
    XPUSHs(sv_pkg);
    spec = freeSpec(spec);
  } else {
    XPUSHs(&PL_sv_undef);
    /* apparently rpmlib sets errno this when given a bad spec. */
    if (errno == EBADF)
      errno = 0;
  }
  ts = rpmtsFree(ts);
#line 7454 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_expand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_expand)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 4014 "URPM.xs"
    const char * value = rpmExpand(name, NULL);
    XPUSHs(sv_2mortal(newSVpv(value, 0)));
#line 7478 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_add_macro_noexpand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_add_macro_noexpand)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "macro");
    {
	char *	macro = (char *)SvPV_nolen(ST(0));
#line 4021 "URPM.xs"
    rpmDefineMacro(NULL, macro, RMIL_DEFAULT);
#line 7499 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_del_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_del_macro)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 4027 "URPM.xs"
    delMacro(NULL, name);
#line 7519 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_loadmacrosfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_loadmacrosfile)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 4033 "URPM.xs"
    rpmInitMacros(NULL, filename);
#line 7541 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_resetmacros); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_resetmacros)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4038 "URPM.xs"
    rpmFreeMacros(NULL);
#line 7563 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_setVerbosity); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_setVerbosity)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "level");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	level = (int)SvIV(ST(0));
#line 4044 "URPM.xs"
    rpmSetVerbosity(level);
#line 7586 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_rpmErrorString); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorString)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 4049 "URPM.xs"
  RETVAL = rpmlogMessage();
#line 7608 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_rpmErrorWriteTo); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorWriteTo)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
#line 4057 "URPM.xs"
  rpmError_callback_data = fd;
  rpmlogSetCallback(rpmError_callback, NULL);

  /* vim:set ts=8 sts=2 sw=2: */
#line 7632 "URPM.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_URPM); /* prototype to pass -Wmissing-prototypes */
XS(boot_URPM)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXS("URPM::Package::DESTROY", XS_URPM__Package_DESTROY, file);
        (void)newXS("URPM::Package::name", XS_URPM__Package_name, file);
        (void)newXS("URPM::Package::version", XS_URPM__Package_version, file);
        (void)newXS("URPM::Package::release", XS_URPM__Package_release, file);
        (void)newXS("URPM::Package::disttag", XS_URPM__Package_disttag, file);
        (void)newXS("URPM::Package::distepoch", XS_URPM__Package_distepoch, file);
        (void)newXS("URPM::Package::arch", XS_URPM__Package_arch, file);
        (void)newXS("URPM::Package::is_arch_compat__XS", XS_URPM__Package_is_arch_compat__XS, file);
        (void)newXS("URPM::Package::is_platform_compat", XS_URPM__Package_is_platform_compat, file);
        (void)newXS("URPM::Package::summary", XS_URPM__Package_summary, file);
        (void)newXS("URPM::Package::description", XS_URPM__Package_description, file);
        (void)newXS("URPM::Package::sourcerpm", XS_URPM__Package_sourcerpm, file);
        (void)newXS("URPM::Package::packager", XS_URPM__Package_packager, file);
        (void)newXS("URPM::Package::buildhost", XS_URPM__Package_buildhost, file);
        (void)newXS("URPM::Package::buildtime", XS_URPM__Package_buildtime, file);
        (void)newXS("URPM::Package::installtid", XS_URPM__Package_installtid, file);
        (void)newXS("URPM::Package::url", XS_URPM__Package_url, file);
        (void)newXS("URPM::Package::license", XS_URPM__Package_license, file);
        (void)newXS("URPM::Package::distribution", XS_URPM__Package_distribution, file);
        (void)newXS("URPM::Package::vendor", XS_URPM__Package_vendor, file);
        (void)newXS("URPM::Package::os", XS_URPM__Package_os, file);
        (void)newXS("URPM::Package::payload_format", XS_URPM__Package_payload_format, file);
        (void)newXS("URPM::Package::evr", XS_URPM__Package_evr, file);
        (void)newXS("URPM::Package::fullname", XS_URPM__Package_fullname, file);
        (void)newXS("URPM::Package::epoch", XS_URPM__Package_epoch, file);
        (void)newXS("URPM::Package::compare_pkg", XS_URPM__Package_compare_pkg, file);
        (void)newXS("URPM::Package::compare", XS_URPM__Package_compare, file);
        (void)newXS("URPM::Package::size", XS_URPM__Package_size, file);
        (void)newXS("URPM::Package::filesize", XS_URPM__Package_filesize, file);
        (void)newXS("URPM::Package::group", XS_URPM__Package_group, file);
        (void)newXS("URPM::Package::filename", XS_URPM__Package_filename, file);
        (void)newXS("URPM::Package::header_filename", XS_URPM__Package_header_filename, file);
        (void)newXS("URPM::Package::id", XS_URPM__Package_id, file);
        (void)newXS("URPM::Package::set_id", XS_URPM__Package_set_id, file);
        (void)newXS("URPM::Package::requires", XS_URPM__Package_requires, file);
        (void)newXS("URPM::Package::requires_nosense", XS_URPM__Package_requires_nosense, file);
        (void)newXS("URPM::Package::suggests", XS_URPM__Package_suggests, file);
        (void)newXS("URPM::Package::obsoletes", XS_URPM__Package_obsoletes, file);
        (void)newXS("URPM::Package::obsoletes_nosense", XS_URPM__Package_obsoletes_nosense, file);
        (void)newXS("URPM::Package::obsoletes_overlap", XS_URPM__Package_obsoletes_overlap, file);
        (void)newXS("URPM::Package::conflicts", XS_URPM__Package_conflicts, file);
        (void)newXS("URPM::Package::conflicts_nosense", XS_URPM__Package_conflicts_nosense, file);
        (void)newXS("URPM::Package::provides", XS_URPM__Package_provides, file);
        (void)newXS("URPM::Package::provides_nosense", XS_URPM__Package_provides_nosense, file);
        (void)newXS("URPM::Package::provides_overlap", XS_URPM__Package_provides_overlap, file);
        (void)newXS("URPM::Package::buildarchs", XS_URPM__Package_buildarchs, file);
        (void)newXS("URPM::Package::excludearchs", XS_URPM__Package_excludearchs, file);
        (void)newXS("URPM::Package::exclusivearchs", XS_URPM__Package_exclusivearchs, file);
        (void)newXS("URPM::Package::dirnames", XS_URPM__Package_dirnames, file);
        (void)newXS("URPM::Package::filelinktos", XS_URPM__Package_filelinktos, file);
        (void)newXS("URPM::Package::files", XS_URPM__Package_files, file);
        (void)newXS("URPM::Package::files_digest", XS_URPM__Package_files_digest, file);
        (void)newXS("URPM::Package::files_md5sum", XS_URPM__Package_files_md5sum, file);
        (void)newXS("URPM::Package::files_owner", XS_URPM__Package_files_owner, file);
        (void)newXS("URPM::Package::files_group", XS_URPM__Package_files_group, file);
        (void)newXS("URPM::Package::files_mtime", XS_URPM__Package_files_mtime, file);
        (void)newXS("URPM::Package::files_size", XS_URPM__Package_files_size, file);
        (void)newXS("URPM::Package::files_uid", XS_URPM__Package_files_uid, file);
        (void)newXS("URPM::Package::files_gid", XS_URPM__Package_files_gid, file);
        (void)newXS("URPM::Package::files_mode", XS_URPM__Package_files_mode, file);
        (void)newXS("URPM::Package::files_flags", XS_URPM__Package_files_flags, file);
        (void)newXS("URPM::Package::conf_files", XS_URPM__Package_conf_files, file);
        (void)newXS("URPM::Package::changelog_time", XS_URPM__Package_changelog_time, file);
        (void)newXS("URPM::Package::changelog_name", XS_URPM__Package_changelog_name, file);
        (void)newXS("URPM::Package::changelog_text", XS_URPM__Package_changelog_text, file);
        (void)newXS("URPM::Package::queryformat", XS_URPM__Package_queryformat, file);
        (void)newXS("URPM::Package::get_tag", XS_URPM__Package_get_tag, file);
        (void)newXS("URPM::Package::get_tag_modifiers", XS_URPM__Package_get_tag_modifiers, file);
        (void)newXS("URPM::Package::pack_header", XS_URPM__Package_pack_header, file);
        (void)newXS("URPM::Package::update_header", XS_URPM__Package_update_header, file);
        (void)newXS("URPM::Package::free_header", XS_URPM__Package_free_header, file);
        (void)newXS("URPM::Package::build_info", XS_URPM__Package_build_info, file);
        (void)newXS("URPM::Package::build_header", XS_URPM__Package_build_header, file);
        (void)newXS("URPM::Package::flag", XS_URPM__Package_flag, file);
        (void)newXS("URPM::Package::set_flag", XS_URPM__Package_set_flag, file);
        (void)newXS("URPM::Package::flag_skip", XS_URPM__Package_flag_skip, file);
        (void)newXS("URPM::Package::set_flag_skip", XS_URPM__Package_set_flag_skip, file);
        (void)newXS("URPM::Package::flag_base", XS_URPM__Package_flag_base, file);
        (void)newXS("URPM::Package::set_flag_base", XS_URPM__Package_set_flag_base, file);
        (void)newXS("URPM::Package::flag_disable_obsolete", XS_URPM__Package_flag_disable_obsolete, file);
        (void)newXS("URPM::Package::set_flag_disable_obsolete", XS_URPM__Package_set_flag_disable_obsolete, file);
        (void)newXS("URPM::Package::flag_installed", XS_URPM__Package_flag_installed, file);
        (void)newXS("URPM::Package::set_flag_installed", XS_URPM__Package_set_flag_installed, file);
        (void)newXS("URPM::Package::flag_requested", XS_URPM__Package_flag_requested, file);
        (void)newXS("URPM::Package::set_flag_requested", XS_URPM__Package_set_flag_requested, file);
        (void)newXS("URPM::Package::flag_required", XS_URPM__Package_flag_required, file);
        (void)newXS("URPM::Package::set_flag_required", XS_URPM__Package_set_flag_required, file);
        (void)newXS("URPM::Package::flag_upgrade", XS_URPM__Package_flag_upgrade, file);
        (void)newXS("URPM::Package::set_flag_upgrade", XS_URPM__Package_set_flag_upgrade, file);
        (void)newXS("URPM::Package::flag_selected", XS_URPM__Package_flag_selected, file);
        (void)newXS("URPM::Package::flag_available", XS_URPM__Package_flag_available, file);
        (void)newXS("URPM::Package::rate", XS_URPM__Package_rate, file);
        (void)newXS("URPM::Package::set_rate", XS_URPM__Package_set_rate, file);
        (void)newXS("URPM::Package::rflags", XS_URPM__Package_rflags, file);
        (void)newXS("URPM::Package::set_rflags", XS_URPM__Package_set_rflags, file);
        (void)newXS("URPM::DB::open", XS_URPM__DB_open, file);
        (void)newXS("URPM::DB::rebuild", XS_URPM__DB_rebuild, file);
        (void)newXS("URPM::DB::verify", XS_URPM__DB_verify, file);
        (void)newXS("URPM::DB::DESTROY", XS_URPM__DB_DESTROY, file);
        (void)newXS("URPM::DB::traverse", XS_URPM__DB_traverse, file);
        (void)newXS("URPM::DB::traverse_tag", XS_URPM__DB_traverse_tag, file);
        (void)newXS("URPM::DB::traverse_tag_find", XS_URPM__DB_traverse_tag_find, file);
        (void)newXS("URPM::DB::create_transaction", XS_URPM__DB_create_transaction, file);
        (void)newXS("URPM::Transaction::DESTROY", XS_URPM__Transaction_DESTROY, file);
        (void)newXS("URPM::Transaction::set_script_fd", XS_URPM__Transaction_set_script_fd, file);
        (void)newXS("URPM::Transaction::add", XS_URPM__Transaction_add, file);
        (void)newXS("URPM::Transaction::remove", XS_URPM__Transaction_remove, file);
        (void)newXS("URPM::Transaction::traverse", XS_URPM__Transaction_traverse, file);
        (void)newXS("URPM::Transaction::check", XS_URPM__Transaction_check, file);
        (void)newXS("URPM::Transaction::order", XS_URPM__Transaction_order, file);
        (void)newXS("URPM::Transaction::NElements", XS_URPM__Transaction_NElements, file);
        (void)newXS("URPM::Transaction::Element_name", XS_URPM__Transaction_Element_name, file);
        (void)newXS("URPM::Transaction::Element_epoch", XS_URPM__Transaction_Element_epoch, file);
        (void)newXS("URPM::Transaction::Element_version", XS_URPM__Transaction_Element_version, file);
        (void)newXS("URPM::Transaction::Element_release", XS_URPM__Transaction_Element_release, file);
        (void)newXS("URPM::Transaction::Element_distepoch", XS_URPM__Transaction_Element_distepoch, file);
        (void)newXS("URPM::Transaction::Element_fullname", XS_URPM__Transaction_Element_fullname, file);
        (void)newXS("URPM::Transaction::run", XS_URPM__Transaction_run, file);
        (void)newXS("URPM::bind_rpm_textdomain_codeset", XS_URPM_bind_rpm_textdomain_codeset, file);
        (void)newXS("URPM::read_config_files", XS_URPM_read_config_files, file);
        (void)newXS("URPM::list_rpm_tag", XS_URPM_list_rpm_tag, file);
        (void)newXS("URPM::rpmvercmp", XS_URPM_rpmvercmp, file);
        (void)newXS("URPM::rpmEVRcmp", XS_URPM_rpmEVRcmp, file);
        (void)newXS("URPM::rpmEVRcompare", XS_URPM_rpmEVRcompare, file);
        (void)newXS("URPM::ranges_overlap", XS_URPM_ranges_overlap, file);
        (void)newXS("URPM::parse_synthesis__XS", XS_URPM_parse_synthesis__XS, file);
        (void)newXS("URPM::parse_hdlist__XS", XS_URPM_parse_hdlist__XS, file);
        (void)newXS("URPM::parse_rpm", XS_URPM_parse_rpm, file);
        (void)newXS("URPM::verify_rpm", XS_URPM_verify_rpm, file);
        (void)newXS("URPM::get_gpg_fingerprint", XS_URPM_get_gpg_fingerprint, file);
        (void)newXS("URPM::verify_signature", XS_URPM_verify_signature, file);
        (void)newXS("URPM::import_pubkey_file", XS_URPM_import_pubkey_file, file);
        (void)newXS("URPM::import_pubkey", XS_URPM_import_pubkey, file);
        (void)newXS("URPM::archscore", XS_URPM_archscore, file);
        (void)newXS("URPM::osscore", XS_URPM_osscore, file);
        (void)newXS("URPM::platformscore", XS_URPM_platformscore, file);
        (void)newXS("URPM::stream2header", XS_URPM_stream2header, file);
        (void)newXS("URPM::spec2srcheader", XS_URPM_spec2srcheader, file);
        (void)newXS("URPM::expand", XS_URPM_expand, file);
        (void)newXS("URPM::add_macro_noexpand", XS_URPM_add_macro_noexpand, file);
        (void)newXS("URPM::del_macro", XS_URPM_del_macro, file);
        (void)newXS("URPM::loadmacrosfile", XS_URPM_loadmacrosfile, file);
        (void)newXS("URPM::resetmacros", XS_URPM_resetmacros, file);
        (void)newXS("URPM::setVerbosity", XS_URPM_setVerbosity, file);
        (void)newXS("URPM::rpmErrorString", XS_URPM_rpmErrorString, file);
        (void)newXS("URPM::rpmErrorWriteTo", XS_URPM_rpmErrorWriteTo, file);

    /* Initialisation Section */

#line 3360 "URPM.xs"
(void) read_config_files(0);

#line 7810 "URPM.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

